/**
 * @license
 * Copyright 2021 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
!function(e,n){"object"==typeof exports&&"undefined"!=typeof module?n(exports,require("@tensorflow/tfjs-core"),require("path"),require("fs"),require("worker_threads"),require("perf_hooks")):"function"==typeof define&&define.amd?define(["exports","@tensorflow/tfjs-core","path","fs","worker_threads","perf_hooks"],n):n(((e=e||self).tf=e.tf||{},e.tf.wasm=e.tf.wasm||{}),e.tf,e.path,e.fs,e.worker_threads,e.perf_hooks)}(this,(function(e,n,t,a,r,s){"use strict";var u,i;let o;t=t&&t.hasOwnProperty("default")?t.default:t,a=a&&a.hasOwnProperty("default")?a.default:a,r=r&&r.hasOwnProperty("default")?r.default:r,s=s&&s.hasOwnProperty("default")?s.default:s,function(e){e[e.float32=0]="float32",e[e.int32=1]="int32",e[e.bool=2]="bool",e[e.string=3]="string",e[e.complex64=4]="complex64"}(u||(u={})),function(e){e[e.linear=0]="linear",e[e.relu=1]="relu",e[e.relu6=2]="relu6",e[e.prelu=3]="prelu",e[e.leakyrelu=4]="leakyrelu"}(i||(i={}));const l={kernelName:n._FusedMatMul,backendName:"wasm",setupFunc:function(e){o=e.wasm.cwrap(n._FusedMatMul,null,["number","array","number","number","array","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:t,attrs:a}=e,{a:r,b:s,bias:u,preluActivationWeights:l}=n;if("float32"!==r.dtype||"float32"!==s.dtype)throw new Error("_FusedMatMul for non non-float32 tensors not yet supported.");const{transposeA:d,transposeB:c,activation:p,leakyreluAlpha:m}=a,f=t.dataIdMap.get(r.dataId).id,h=t.dataIdMap.get(s.dataId).id;let b=0;if(null!=u){const e=t.dataIdMap.get(u.dataId);if(1!==e.shape.length)throw new Error(`_FusedMatMul only supports rank-1 bias but got rank ${e.shape.length}.`);b=e.id}const _=null==l?0:t.dataIdMap.get(l.dataId).id,y=i[p];if(null==y)throw new Error(p+" activation not yet supported for FusedConv2D in the wasm backend.");const g=d?r.shape[2]:r.shape[1],w=c?s.shape[1]:s.shape[2],k=r.shape[0],I=t.makeOutput([k,g,w],r.dtype),v=t.dataIdMap.get(I.dataId).id,S=new Uint8Array(new Int32Array(r.shape).buffer),E=new Uint8Array(new Int32Array(s.shape).buffer);return o(f,S,r.shape.length,h,E,s.shape.length,d,c,y,b,_,m||0,v),I}};function d(e){let t;return{kernelName:e,backendName:"wasm",setupFunc:function(n){t=n.wasm.cwrap(e,null,["number","number"])},kernelFunc:function(e){const{backend:a,inputs:{x:r}}=e,s=a.dataIdMap.get(r.dataId).id,u=a.makeOutput(r.shape,r.dtype),i=a.dataIdMap.get(u.dataId).id;return 0===n.util.sizeFromShape(u.shape)||t(s,i),u}}}const c=d(n.Abs);function p(e,t,a){let r;return{kernelName:e,backendName:"wasm",setupFunc:function(n){r=n.wasm.cwrap(e,null,["number","array","number","number","array","number","number","number"])},kernelFunc:function(s){const{backend:i,inputs:o}=s,{a:l,b:d}=o,c=i.dataIdMap.get(l.dataId).id,p=i.dataIdMap.get(d.dataId).id,m=null!=a?a:l.dtype,f=n.backend_util.assertAndGetBroadcastShape(l.shape,d.shape),h=i.makeOutput(f,m);if(0===n.util.sizeFromShape(f))return h;const b=new Uint8Array(new Int32Array(l.shape).buffer),_=new Uint8Array(new Int32Array(d.shape).buffer),y=i.dataIdMap.get(h.dataId).id,g=()=>r(c,b,l.shape.length,p,_,d.shape.length,u[l.dtype],y);if(t&&"float32"===l.dtype)return g(),h;const w=n.backend_util.getBroadcastDims(l.shape,f),k=n.backend_util.getBroadcastDims(d.shape,f),I=w.every((e,n)=>e===n),v=k.every((e,n)=>e===n);if(I&&v)return g(),h;throw new Error(`Broadcasting along outer dims is not yet supported for ${l.dtype} ${e}.`)}}}const m=p(n.Add,!0);let f;const h={kernelName:n.AddN,backendName:"wasm",setupFunc:function(e){f=e.wasm.cwrap(n.AddN,null,["array","number","number","number"])},kernelFunc:function(e){const{inputs:t,backend:a}=e,r=a.makeOutput(t[0].shape,t[0].dtype);if(0===n.util.sizeFromShape(r.shape))return r;const s=t.map(e=>a.dataIdMap.get(e.dataId).id),i=new Uint8Array(new Int32Array(s).buffer),o=a.dataIdMap.get(r.dataId).id;return f(i,s.length,u[r.dtype],o),r}};function b(e){const{inputs:{x:n},backend:t}=e,a=t.makeOutput(n.shape,n.dtype),r=t.typedArrayFromHeap(n);return t.typedArrayFromHeap(a).set(r),a}const _={kernelName:n.Identity,backendName:"wasm",kernelFunc:b};let y;function g(e){const{inputs:n,backend:t,attrs:a}=e,[r,s]=function(e,n){const t=[],a=[];for(let r=0;r<e.length;++r)1!==e[r]&&t.push(e[r]),1!==e[n[r]]&&a.push(n[r]);for(let e=0;e<a.length;++e){let n=-1;for(let t=0;t<a.length;++t)a[t]>=e&&(-1===n||a[n]>a[t])&&(n=t);a[n]=e}return[t,a]}(n.x.shape,a.perm);let i=!0;for(let e=0;e<s.length;e++)s[e]!==e&&(i=!1);const o=function(e,n){const t=new Array(e.length);for(let a=0;a<t.length;a++)t[a]=e[n[a]];return t}(n.x.shape,a.perm),l={dataId:n.x.dataId,shape:r,dtype:n.x.dtype};if(i){const e=b({inputs:n,backend:t});return e.shape=o,e}const d=t.makeOutput(o,l.dtype),c=t.dataIdMap.get(l.dataId).id,p=t.dataIdMap.get(d.dataId).id,m=new Uint8Array(new Int32Array(s).buffer),f=new Uint8Array(new Int32Array(l.shape).buffer);return y(c,f,l.shape.length,u[l.dtype],p,m,s.length),d}const w={kernelName:n.Transpose,backendName:"wasm",kernelFunc:g,setupFunc:function(e){y=e.wasm.cwrap(n.Transpose,null,["number","array","number","number","number","array","number"])}};function k(e,t,a){const r=e.shape,s=e.shape.length,u=n.util.parseAxisParam(t,r);let i=u;const o=n.backend_util.getAxesPermutation(i,s);let l=null,d=!1;if(null!=o){const t=new Array(s);for(let e=0;e<t.length;e++)t[e]=r[o[e]];i=n.backend_util.getInnerMostAxes(i.length,s),l=g({inputs:{x:e},attrs:{perm:o},backend:a});const u=a.dataIdMap.get(e.dataId).id;a.dataIdMap.get(l.dataId).id!==u&&(d=!0)}return{transposed:l,originalAxes:u,axes:i,inputWasTransposed:d}}let I;const v={kernelName:n.ArgMax,backendName:"wasm",kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{axis:s}=r,{x:i}=a,o=t.dataIdMap.get(i.dataId).id;let l=o,d=i;const{transposed:c,axes:p,inputWasTransposed:m}=k(i,s,t);if(m){const e=t.dataIdMap.get(c.dataId).id;e!==o&&(d=c,l=e)}const f=d.shape.slice(0,-1),h=t.makeOutput(f,"int32"),b=t.dataIdMap.get(h.dataId).id,_=n.util.sizeFromShape(h.shape),y=d.shape[p[0]];return I(l,u[d.dtype],_,y,b),m&&t.disposeData(c.dataId),h},setupFunc:function(e){I=e.wasm.cwrap(n.ArgMax,null,["number","number","number","number","number"])}};let S;const E={kernelName:n.AvgPool,backendName:"wasm",setupFunc:function(e){S=e.wasm.cwrap(n.AvgPool,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,attrs:a,backend:r}=e,s=t.x,u=r.dataIdMap.get(s.dataId).id,{filterSize:i,strides:o,pad:l,dimRoundingMode:d}=a,c=n.backend_util.computePool2DInfo(s.shape,i,o,1,l,d),p=c.filterHeight,m=c.filterWidth,f=c.padInfo.top,h=c.padInfo.right,b=c.padInfo.bottom,_=c.padInfo.left,y=c.strideHeight,g=c.strideWidth,w=c.inChannels;if("channelsLast"!==c.dataFormat)throw new Error("wasm backend does not support dataFormat:'"+c.dataFormat+"'. Please use 'channelsLast'.");if(1!==c.dilationWidth||1!==c.dilationHeight)throw new Error(`was backend only supports average pooling with dilation = [1, 1], got [${c.dilationHeight}, ${c.dilationWidth}].`);const k=r.makeOutput(c.outShape,"float32"),I=r.dataIdMap.get(k.dataId).id;return S(u,s.shape[0],s.shape[1],s.shape[2],p,m,f,h,b,_,y,g,w,I),k}};function A(e){const{inputs:t,attrs:a}=e,{x:r}=t,{shape:s}=a,u=n.util.sizeFromShape(r.shape),i=n.util.inferFromImplicitShape(s,u);return n.util.assert(u===n.util.sizeFromShape(i),()=>`new shape: ${i}, old shape: ${r.shape}. New shape and old shape must have the same number of elements.`),{dataId:r.dataId,shape:i,dtype:r.dtype}}const M={kernelName:n.Reshape,backendName:"wasm",kernelFunc:A};let x;const N={kernelName:n.BatchMatMul,backendName:"wasm",setupFunc:function(e){x=e.wasm.cwrap(n.BatchMatMul,null,["number","array","number","number","array","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,backend:a,attrs:r}=e,{a:s,b:u}=t,{transposeA:i,transposeB:o}=r;if("float32"!==s.dtype||"float32"!==u.dtype)throw new Error("BatchMatMul for non non-float32 tensors not yet supported.");const l=s.shape.length,d=u.shape.length,c=i?s.shape[l-2]:s.shape[l-1],p=o?u.shape[d-1]:u.shape[d-2],m=i?s.shape[l-1]:s.shape[l-2],f=o?u.shape[d-2]:u.shape[d-1],h=s.shape.slice(0,-2),b=u.shape.slice(0,-2),_=n.util.sizeFromShape(h),y=n.util.sizeFromShape(b),g=_===y||1===_||1===y;n.util.assert(l>=2&&d>=2&&g,()=>`Error in matMul: the input batch dimensions must either be the same or at least one input batch dimension must be 1. Got input batch dimensions of (${h}) and (${b}).`);const w=(_>y?s.shape.slice(0,-2):u.shape.slice(0,-2)).concat([m,f]);n.util.assert(c===p,()=>`Error in matMul: inner shapes (${c}) and (${p}) of Tensors with shapes ${s.shape} and ${u.shape} and transposeA=${i} and transposeB=${o} must match.`);const k=o?[y,f,p]:[y,p,f],I=A({inputs:{x:s},backend:a,attrs:{shape:i?[_,c,m]:[_,m,c]}}),v=A({inputs:{x:u},backend:a,attrs:{shape:k}}),S=a.dataIdMap.get(I.dataId).id,E=a.dataIdMap.get(v.dataId).id,M=i?I.shape[2]:I.shape[1],N=o?v.shape[1]:v.shape[2],F=Math.max(_,y),T=a.makeOutput([F,M,N],I.dtype),O=a.dataIdMap.get(T.dataId).id,C=new Uint8Array(new Int32Array(I.shape).buffer),R=new Uint8Array(new Int32Array(v.shape).buffer);return x(S,C,I.shape.length,E,R,v.shape.length,i,o,O),T.shape=w,T}};function F(e){const{inputs:{x:n},attrs:{dtype:t},backend:a}=e,r=a.makeOutput(n.shape,t),s=a.typedArrayFromHeap(n);return a.typedArrayFromHeap(r).set(s),r}const T={kernelName:n.Cast,backendName:"wasm",kernelFunc:F};let O;const C={kernelName:n.ClipByValue,backendName:"wasm",setupFunc:function(e){O=e.wasm.cwrap(n.ClipByValue,null,["number","number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:t,attrs:a}=e,{x:r}=n,{clipValueMin:s,clipValueMax:u}=a,i=t.dataIdMap.get(r.dataId).id,o=t.makeOutput(r.shape,r.dtype),l=t.dataIdMap.get(o.dataId).id;return O(i,s,u,l),o}};function R(e,t,a,r,s){const u=n.slice_util.isSliceContinous(r,t,a),i=n.util.sizeFromShape(a),o=n.util.computeStrides(r);if(u){const a=n.slice_util.computeFlatOffset(t,o);return"string"===s?e.slice(a,a+i):e.subarray(a,a+i)}const l="string"===s?n.backend_util.fromUint8ToStringArray(e):e,d=n.buffer(r,s,l),c=n.buffer(a,s);for(let e=0;e<c.size;++e){const n=c.indexToLoc(e),a=n.map((e,n)=>e+t[n]);c.set(d.get(...a),...n)}return"string"===s?n.backend_util.fromStringArrayToUint8(c.values):c.values}function D(e){const{inputs:t,backend:a}=e,r=n.util.parseAxisParam(e.attrs.axis,t[0].shape)[0];let s=n.backend_util.computeOutShape(t.map(e=>e.shape),r);const u=t.filter(e=>n.util.sizeFromShape(e.shape)>0);if(1===u.length)return b({inputs:{x:u[0]},backend:a});const i=a.makeOutput(s,t[0].dtype);if(0===n.util.sizeFromShape(s))return i;const o=u.map(e=>e.shape);if(n.backend_util.assertParamsConsistent(o,r),"string"===u[0].dtype){const e=u.map(e=>{const t=n.util.sizeFromShape(e.shape.slice(r));return A({inputs:{x:e},backend:a,attrs:{shape:[-1,t]}})}),o=e.map(e=>({vals:a.readSync(e.dataId),shape:e.shape}));s=n.backend_util.computeOutShape(e.map(e=>e.shape),1);const l=1===e[0].shape[0],d=function(e,t,a,r){const s=n.util.getArrayFromDType(a,n.util.sizeFromShape(t));if(r&&"string"!==a){let t=0;e.forEach(e=>{const a=n.util.sizeFromShape(e.shape);s.set(e.vals,t),t+=a})}else{let r=0;e.forEach(e=>{const u="string"===a?n.backend_util.fromUint8ToStringArray(e.vals):e.vals;let i=0;for(let n=0;n<e.shape[0];++n){const a=n*t[1]+r;for(let n=0;n<e.shape[1];++n)s[a+n]=u[i++]}r+=e.shape[1]})}return s}(o,s,t[0].dtype,l),c=n.backend_util.computeOutShape(u.map(e=>e.shape),r);i.shape=c;return a.dataIdMap.get(i.dataId).stringBytes=n.backend_util.fromStringArrayToUint8(d),i}const l=n.util.sizeFromShape(u[0].shape.slice(0,r));let d=0;const c=u.map(e=>{const t=n.util.sizeFromShape(e.shape.slice(r));return d+=t,t}),p=u.map(e=>a.typedArrayFromHeap(e)),m=a.typedArrayFromHeap(i);for(let e=0;e<l;e++){let n=e*d;for(let t=0;t<p.length;t++){const a=c[t],r=e*a,s=p[t].subarray(r,r+a);m.set(s,n),n+=a}}return i}const P={kernelName:n.Concat,backendName:"wasm",kernelFunc:D};let W;const B={kernelName:n.Conv2D,backendName:"wasm",setupFunc:function(e){W=e.wasm.cwrap(n.Conv2D,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,attrs:a,backend:r}=e,{x:s,filter:u}=t,i=r.dataIdMap.get(s.dataId).id,o=r.dataIdMap.get(u.dataId).id,{strides:l,dilations:d,pad:c,dimRoundingMode:p,dataFormat:m}=a,f=n.backend_util.convertConv2DDataFormat(m),h=n.backend_util.computeConv2DInfo(s.shape,u.shape,l,d,c,p,!1,f),b=h.filterHeight,_=h.filterWidth,y=h.padInfo.top,g=h.padInfo.right,w=h.padInfo.bottom,k=h.padInfo.left,I=h.dilationHeight,v=h.dilationWidth,S=h.strideHeight,E=h.strideWidth,A=h.inChannels,M=h.outChannels,x="SAME"===h.padInfo.type?1:0;if("channelsLast"!==h.dataFormat)throw new Error("wasm backend Conv2D does not support dataFormat:'"+h.dataFormat+"'. Please use 'channelsLast'.");const N=r.makeOutput(h.outShape,"float32"),F=r.dataIdMap.get(N.dataId).id;return W(i,s.shape[0],s.shape[1],s.shape[2],o,b,_,y,g,w,k,x,I,v,S,E,A,M,F),N}};let L;const H={kernelName:n.Conv2DBackpropInput,backendName:"wasm",setupFunc:function(e){L=e.wasm.cwrap(n.Conv2DBackpropInput,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{dy:s,filter:u}=a,{strides:i,pad:o,dataFormat:l,dimRoundingMode:d,inputShape:c}=r,p=n.backend_util.convertConv2DDataFormat(l),m=n.backend_util.computeConv2DInfo(c,u.shape,i,1,o,d,!1,p),{batchSize:f,filterHeight:h,filterWidth:b,inChannels:_,inHeight:y,inWidth:g,outChannels:w,outHeight:k,outWidth:I,strideHeight:v,strideWidth:S}=m,E=h-1-m.padInfo.top,A=b-1-m.padInfo.left,M="channelsLast"===m.dataFormat,x=n.util.computeStrides(m.inShape),N=n.util.computeStrides(s.shape),[F,T,O]=n.util.computeStrides(u.shape),C=x[0],R=M?x[1]:x[2],D=M?x[2]:1,P=M?1:x[1],W=N[0],B=M?N[1]:N[2],H=M?N[2]:1,U=M?1:N[1],z=t.makeOutput(m.inShape,"float32"),q=t.dataIdMap.get(z.dataId).id,j=t.dataIdMap.get(s.dataId).id,V=t.dataIdMap.get(u.dataId).id;return L(j,V,f,h,b,y,g,_,k,I,w,v,S,E,A,F,T,O,C,R,D,P,W,B,H,U,q),z}},U=d(n.Cos);var z;let q;!function(e){e[e.bilinear=0]="bilinear",e[e.nearest=1]="nearest"}(z||(z={}));const j={kernelName:n.CropAndResize,backendName:"wasm",setupFunc:function(e){q=e.wasm.cwrap(n.CropAndResize,null,["number","number","number","number","array","number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:t,attrs:a}=e,{method:r,extrapolationValue:s,cropSize:u}=a,{image:i,boxes:o,boxInd:l}=t,d=o.shape[0],[c,p]=u,m=[d,c,p,i.shape[3]];let f,h=n.dataIdMap.get(i.dataId);"float32"!==i.dtype&&(f=F({backend:n,inputs:{x:i},attrs:{dtype:"float32"}}),h=n.dataIdMap.get(f.dataId));const b=h.id,_=n.dataIdMap.get(o.dataId).id,y=n.dataIdMap.get(l.dataId).id,g=n.makeOutput(m,"float32"),w=n.dataIdMap.get(g.dataId).id,k=new Uint8Array(new Int32Array(i.shape).buffer);return q(b,_,y,d,k,c,p,z[r],s,w),null!=f&&n.disposeData(f.dataId),g}};let V;const G={kernelName:n.Cumsum,backendName:"wasm",setupFunc:function(e){V=e.wasm.cwrap(n.Cumsum,null,["number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,backend:a,attrs:r}=e,{x:s}=t,{axis:i,exclusive:o,reverse:l}=r,d=s.shape.length;n.util.assert("float32"===s.dtype||"int32"===s.dtype,()=>`cumsum does not support ${s.dtype} tensors in the WASM backend`);const c=n.backend_util.getAxesPermutation([i],d);let p=s;null!==c&&(p=g({inputs:{x:s},attrs:{perm:c},backend:a}));const m=n.backend_util.getInnerMostAxes(1,d)[0];n.backend_util.assertAxesAreInnerMostDims("cumsum",[m],d);const f=a.makeOutput(p.shape,p.dtype),h=p.shape[m],b=a.dataIdMap.get(p.dataId).id,_=a.dataIdMap.get(f.dataId).id;V(b,o?1:0,l?1:0,h,_,u[s.dtype]);let y=f;if(null!==c){y=g({inputs:{x:f},attrs:{perm:n.backend_util.getUndoAxesPermutation(c)},backend:a}),a.disposeData(p.dataId),a.disposeData(f.dataId)}return y}};let K;const X={kernelName:n.DepthToSpace,backendName:"wasm",setupFunc:function(e){K=e.wasm.cwrap(n.DepthToSpace,null,["number","number","number","array","number","array","array","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{x:s}=a,{blockSize:u,dataFormat:i}=r;n.util.assert(u>1,()=>"blockSize should be > 1 for depthToSpace, but was: "+u);const o=s.shape[0],l="NHWC"===i?s.shape[1]:s.shape[2],d="NHWC"===i?s.shape[2]:s.shape[3],c="NHWC"===i?s.shape[3]:s.shape[1],p=l*u,m=d*u,f=c/(u*u),h="NHWC"===i?[o,p,m,f]:[o,f,p,m],b=t.makeOutput(h,"float32"),_=t.dataIdMap.get(s.dataId).id,y=new Uint8Array(new Int32Array(n.util.computeStrides(s.shape)).buffer),g=new Uint8Array(new Int32Array(h).buffer),w=new Uint8Array(new Int32Array(n.util.computeStrides(h)).buffer),k=t.dataIdMap.get(b.dataId).id;return K(_,u,"NHWC"===i?1:0,y,s.shape.length-1,g,w,h.length,k),b}};let $;const Y={kernelName:n.DepthwiseConv2dNative,backendName:"wasm",setupFunc:function(e){$=e.wasm.cwrap(n.DepthwiseConv2dNative,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,attrs:a,backend:r}=e,{x:s,filter:u}=t,i=r.dataIdMap.get(s.dataId).id,o=r.dataIdMap.get(u.dataId).id,{strides:l,dilations:d,pad:c,dimRoundingMode:p}=a,m=null==d?[1,1]:d,f=n.backend_util.computeConv2DInfo(s.shape,u.shape,l,m,c,p,!0),h=f.filterHeight,b=f.filterWidth,_=f.padInfo.top,y=f.padInfo.right,g=f.padInfo.bottom,w=f.padInfo.left,k=f.dilationHeight,I=f.dilationWidth,v=f.strideHeight,S=f.strideWidth,E=f.inChannels,A=f.outChannels,M="SAME"===f.padInfo.type?1:0;if("channelsLast"!==f.dataFormat)throw new Error("wasm backend DepthwiseConv2dNative does not support dataFormat:'"+f.dataFormat+"'. Please use 'channelsLast'.");const x=r.makeOutput(f.outShape,"float32"),N=r.dataIdMap.get(x.dataId).id;return $(i,s.shape[0],s.shape[1],s.shape[2],o,h,b,_,y,g,w,M,k,I,v,S,E,A,N),x}},Q=p(n.Equal,!1,"bool"),Z=d(n.Exp);function J(e){const{inputs:t,attrs:a,backend:r}=e,{input:s}=t,{dim:u}=a,i=s.shape.length,o=s.shape.slice();let l=u;return u<0&&(n.util.assert(-(i+1)<=u,()=>`Axis must be in the interval [${-(i+1)}, ${i}]`),l=i+u+1),o.splice(l,0,1),A({inputs:{x:s},backend:r,attrs:{shape:o}})}const ee={kernelName:n.ExpandDims,backendName:"wasm",kernelFunc:J};const ne={kernelName:n.Fill,backendName:"wasm",kernelFunc:function(e){const{attrs:{shape:n,value:t,dtype:a},backend:r}=e,s=r.makeOutput(n,a);return r.typedArrayFromHeap(s).fill(t),s}};let te;const ae={kernelName:n.FlipLeftRight,backendName:"wasm",kernelFunc:function(e){const{inputs:n,backend:t}=e,{image:a}=n,r=t.makeOutput(a.shape,a.dtype),s=t.dataIdMap.get(a.dataId).id,u=t.dataIdMap.get(r.dataId).id,[i,o,l,d]=a.shape;return te(s,i,o,l,d,u),r},setupFunc:function(e){te=e.wasm.cwrap(n.FlipLeftRight,null,["number","number","number","number","number","number"])}},re=d(n.Floor),se=p(n.FloorDiv,!1);let ue;const ie={kernelName:n.FusedBatchNorm,backendName:"wasm",setupFunc:function(e){ue=e.wasm.cwrap(n.FusedBatchNorm,null,["number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{varianceEpsilon:s}=r,{x:u,mean:i,variance:o,offset:l,scale:d}=a,c=t.dataIdMap.get(u.dataId).id,p=t.dataIdMap.get(i.dataId).id,m=t.dataIdMap.get(o.dataId).id,f=null!=l?t.dataIdMap.get(l.dataId).id:0,h=null!=d?t.dataIdMap.get(d.dataId).id:0,b=t.makeOutput(u.shape,u.dtype);if(0===n.util.sizeFromShape(u.shape))return b;const _=t.dataIdMap.get(b.dataId).id;return ue(c,p,m,f,h,s,_),b}};let oe;const le={kernelName:n.FusedConv2D,backendName:"wasm",setupFunc:function(e){oe=e.wasm.cwrap(n.FusedConv2D,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,attrs:a,backend:r}=e,{x:s,filter:u,bias:o,preluActivationWeights:l}=t,{strides:d,pad:c,dilations:p,dataFormat:m,dimRoundingMode:f,activation:h,leakyreluAlpha:b}=a,_=n.backend_util.computeConv2DInfo(s.shape,u.shape,d,p,c,f),y=i[h];if(null==y)throw new Error(h+" activation not yet supported for FusedConv2D in the wasm backend.");const g=r.dataIdMap.get(s.dataId).id,w=r.dataIdMap.get(u.dataId).id,k=_.outChannels;let I=0;if(null!=o){const e=r.dataIdMap.get(o.dataId);if(1!==e.shape.length)throw new Error(`FusedConv2D only supports rank-1 bias but got rank ${e.shape.length}.`);if(e.shape[0]!==k)throw new Error(`FusedConv2D bias shape (${e.shape}) does not match the number of output channels (${k})`);I=e.id}const v=_.filterHeight,S=_.filterWidth,E=_.padInfo.top,A=_.padInfo.right,M=_.padInfo.bottom,x=_.padInfo.left,N=_.dilationHeight,F=_.dilationWidth,T=_.strideHeight,O=_.strideWidth,C=_.inChannels,R="SAME"===_.padInfo.type?1:0,D=_.batchSize,P=_.inHeight,W=_.inWidth;if("NHWC"!==m)throw new Error("wasm backend FusedConv2D does not support dataFormat:'"+m+"'. Please use 'NHWC'.");const B=r.makeOutput(_.outShape,"float32"),L=r.dataIdMap.get(B.dataId).id,H=null==l?0:r.dataIdMap.get(l.dataId).id;return oe(g,D,P,W,w,v,S,I,E,A,M,x,R,N,F,T,O,C,k,y,H,b||0,L),B}};let de;const ce={kernelName:n.FusedDepthwiseConv2D,backendName:"wasm",setupFunc:function(e){de=e.wasm.cwrap(n.FusedDepthwiseConv2D,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,attrs:a,backend:r}=e,{x:s,filter:u,bias:o,preluActivationWeights:l}=t,{strides:d,pad:c,dilations:p,dataFormat:m,dimRoundingMode:f,activation:h,leakyreluAlpha:b}=a,_=n.backend_util.computeConv2DInfo(s.shape,u.shape,d,p,c,f,!0),y=i[h];if(null==y)throw new Error(h+" activation not yet supported for FusedDepthwiseConv2D in the wasm backend.");const g=r.dataIdMap.get(s.dataId).id,w=r.dataIdMap.get(u.dataId).id,k=_.outChannels;let I=0;if(null!=o){const e=r.dataIdMap.get(o.dataId);if(1!==e.shape.length)throw new Error(`FusedDepthwiseConv2D only supports rank-1 bias but got rank ${e.shape.length}.`);if(e.shape[0]!==k)throw new Error(`FusedDepthwiseConv2D bias shape (${e.shape}) does not match the number of output channels (${k})`);I=e.id}const v=_.filterHeight,S=_.filterWidth,E=_.padInfo.top,A=_.padInfo.right,M=_.padInfo.bottom,x=_.padInfo.left,N=_.dilationHeight,F=_.dilationWidth,T=_.strideHeight,O=_.strideWidth,C=_.inChannels,R="SAME"===_.padInfo.type?1:0,D=_.batchSize,P=_.inHeight,W=_.inWidth;if("NHWC"!==m)throw new Error("wasm backend FusedDepthwiseConv2D does not support dataFormat:'"+m+"'. Please use 'NHWC'.");const B=r.makeOutput(_.outShape,"float32"),L=r.dataIdMap.get(B.dataId).id,H=null==l?0:r.dataIdMap.get(l.dataId).id;return de(g,D,P,W,w,v,S,I,E,A,M,x,R,N,F,T,O,C,k,y,H,b||0,L),B}};let pe;const me={kernelName:n.GatherNd,backendName:"wasm",setupFunc:function(e){pe=e.wasm.cwrap(n.GatherNd,null,["number","number","number","number","number","number","array","number"])},kernelFunc:function(e){const{backend:t,inputs:a}=e,{params:r,indices:s}=a,[i,o,l,d]=n.gather_util.prepareAndValidate(r,s),c=t.makeOutput(i,r.dtype);if(0===o)return c;const p=s.shape,m=p[p.length-1],f=t.dataIdMap.get(r.dataId).id,h=t.dataIdMap.get(s.dataId).id,b=new Uint8Array(new Int32Array(d).buffer),_=t.dataIdMap.get(c.dataId).id;return pe(f,u[r.dtype],h,o,m,l,b,_),c}};let fe;const he={kernelName:n.GatherV2,backendName:"wasm",setupFunc:function(e){fe=e.wasm.cwrap("Gather",null,["number","number","array","number","number","number","array","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{x:s,indices:i}=a,{axis:o,batchDims:l}=r,d=n.util.parseAxisParam(o,s.shape)[0],c=n.backend_util.segment_util.collectGatherOpShapeInfo(s,i,d,l),p=A({inputs:{x:s},attrs:{shape:[c.batchSize,c.outerSize,c.dimSize,c.sliceSize]},backend:t}),m=n.util.sizeFromShape(i.shape),f=A({inputs:{x:i},attrs:{shape:[c.batchSize,m/c.batchSize]},backend:t}),h=[c.batchSize,c.outerSize,m/c.batchSize,c.sliceSize],b=t.makeOutput(h,s.dtype);if(0===n.util.sizeFromShape(s.shape))return b;const _=p.shape.length-1,y=t.dataIdMap.get(p.dataId).id,g=t.dataIdMap.get(f.dataId).id,w=t.dataIdMap.get(b.dataId).id,k=new Uint8Array(new Int32Array(n.util.computeStrides(p.shape)).buffer),I=new Uint8Array(new Int32Array(n.util.computeStrides(h)).buffer);return fe(y,u[s.dtype],k,_,g,c.batchSize,I,w),b.shape=c.outputShape,b}},be=p(n.Greater,!1,"bool"),_e=p(n.GreaterEqual,!1,"bool");let ye;const ge={kernelName:n.LeakyRelu,backendName:"wasm",setupFunc:function(e){ye=e.wasm.cwrap(n.LeakyRelu,null,["number","number","number"])},kernelFunc:function(e){const{inputs:{x:t},attrs:{alpha:a},backend:r}=e,s=r.dataIdMap.get(t.dataId).id,u=r.makeOutput(t.shape,t.dtype);if(0!==n.util.sizeFromShape(t.shape)){const e=r.dataIdMap.get(u.dataId).id;ye(s,a,e)}return u}},we=p(n.Less,!1,"bool"),ke=p(n.LessEqual,!1,"bool"),Ie=d(n.Log),ve=p(n.LogicalAnd,!1,"bool");let Se;const Ee={kernelName:n.Max,backendName:"wasm",setupFunc:function(e){Se=e.wasm.cwrap(n.Max,null,["number, number, number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{reductionIndices:s,keepDims:u}=r,{x:i}=a;let o=t.dataIdMap.get(i.dataId).id,l=i;const{transposed:d,axes:c,originalAxes:p,inputWasTransposed:m}=k(i,s,t);if(m){l=d,o=t.dataIdMap.get(d.dataId).id}const f=l.shape.length;n.backend_util.assertAxesAreInnerMostDims("max",c,f);const[h,b]=n.backend_util.computeOutAndReduceShapes(l.shape,c),_=n.util.sizeFromShape(b),y=t.makeOutput(h,i.dtype);if(0!==n.util.sizeFromShape(l.shape)){const e=t.dataIdMap.get(y.dataId).id;Se(o,_,e)}if(m&&t.disposeData(d.dataId),u){const e=n.backend_util.expandShapeToKeepDim(y.shape,p);y.shape=e}return y}},Ae=p(n.Maximum,!1);let Me;const xe={kernelName:n.MaxPool,backendName:"wasm",setupFunc:function(e){Me=e.wasm.cwrap(n.MaxPool,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:t,attrs:a,backend:r}=e,s=t.x,u=r.dataIdMap.get(s.dataId).id,{filterSize:i,strides:o,pad:l,dimRoundingMode:d}=a,c=n.backend_util.computePool2DInfo(s.shape,i,o,1,l,d),p=c.filterHeight,m=c.filterWidth,f=c.padInfo.top,h=c.padInfo.right,b=c.padInfo.bottom,_=c.padInfo.left,y=c.dilationHeight,g=c.dilationWidth,w=c.strideHeight,k=c.strideWidth,I=c.inChannels,v=c.outChannels;if("channelsLast"!==c.dataFormat)throw new Error("wasm backend does not support dataFormat:'"+c.dataFormat+"'. Please use 'channelsLast'.");const S=r.makeOutput(c.outShape,"float32"),E=r.dataIdMap.get(S.dataId).id;return Me(u,s.shape[0],s.shape[1],s.shape[2],p,m,f,h,b,_,y,g,w,k,I,v,E),S}};let Ne;const Fe={kernelName:n.Mean,backendName:"wasm",setupFunc:function(e){Ne=e.wasm.cwrap(n.Mean,null,["number, number, number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{axis:s,keepDims:u}=r,{x:i}=a,o=t.dataIdMap.get(i.dataId).id;let l=o,d=i;const{transposed:c,axes:p,originalAxes:m,inputWasTransposed:f}=k(i,s,t);let h=p;if(f){const e=t.dataIdMap.get(c.dataId).id;e!==o&&(d=c,l=e,h=n.backend_util.getInnerMostAxes(h.length,d.shape.length))}n.backend_util.assertAxesAreInnerMostDims("mean",h,d.shape.length);const[b,_]=n.backend_util.computeOutAndReduceShapes(d.shape,h),y=n.util.sizeFromShape(_);let g=d;"float32"!==d.dtype&&(g=F({backend:t,inputs:{x:d},attrs:{dtype:"float32"}}),l=t.dataIdMap.get(g.dataId).id);const w=t.makeOutput(b,"float32");if(0!==n.util.sizeFromShape(d.shape)){const e=t.dataIdMap.get(w.dataId).id;Ne(l,y,e)}if(f&&t.disposeData(c.dataId),u){const e=n.backend_util.expandShapeToKeepDim(w.shape,m);w.shape=e}return"float32"!==d.dtype&&t.disposeData(g.dataId),w}};let Te;const Oe={kernelName:n.Min,backendName:"wasm",setupFunc:function(e){Te=e.wasm.cwrap(n.Min,null,["number, number, number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{axis:s,keepDims:u}=r,{x:i}=a,o=t.dataIdMap.get(i.dataId).id;let l=o,d=i;const{transposed:c,axes:p,originalAxes:m,inputWasTransposed:f}=k(i,s,t);if(f){const e=t.dataIdMap.get(c.dataId).id;e!==o&&(d=c,l=e)}const h=d.shape.length;n.backend_util.assertAxesAreInnerMostDims("min",p,h);const[b,_]=n.backend_util.computeOutAndReduceShapes(d.shape,p),y=n.util.sizeFromShape(_),g=t.makeOutput(b,d.dtype);if(0!==n.util.sizeFromShape(d.shape)){const e=t.dataIdMap.get(g.dataId).id;Te(l,y,e)}if(f&&t.disposeData(c.dataId),u){const e=n.backend_util.expandShapeToKeepDim(g.shape,m);g.shape=e}return g}},Ce=p(n.Minimum,!1),Re=p(n.Multiply,!0),De=d(n.Neg);function Pe(e,n){const t=new Int32Array(e.wasm.HEAPU8.buffer,n,4),a=t[0],r=t[1],s=t[2],u=t[3];return e.wasm._free(n),{pSelectedIndices:a,selectedSize:r,pSelectedScores:s,pValidOutputs:u}}let We;const Be={kernelName:n.NonMaxSuppressionV3,backendName:"wasm",setupFunc:function(e){We=e.wasm.cwrap(n.NonMaxSuppressionV3,"number",["number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:t,attrs:a}=e,{iouThreshold:r,maxOutputSize:s,scoreThreshold:u}=a,{boxes:i,scores:o}=t,l=n.dataIdMap.get(i.dataId).id,d=n.dataIdMap.get(o.dataId).id,c=We(l,d,s,r,u),{pSelectedIndices:p,selectedSize:m,pSelectedScores:f,pValidOutputs:h}=Pe(n,c);return n.wasm._free(f),n.wasm._free(h),n.makeOutput([m],"int32",p)}};let Le;const He={kernelName:n.NonMaxSuppressionV4,backendName:"wasm",setupFunc:function(e){Le=e.wasm.cwrap(n.NonMaxSuppressionV4,"number",["number","number","number","number","number","bool"])},kernelFunc:function(e){const{backend:n,inputs:t,attrs:a}=e,{iouThreshold:r,maxOutputSize:s,scoreThreshold:u,padToMaxOutputSize:i}=a,{boxes:o,scores:l}=t,d=n.dataIdMap.get(o.dataId).id,c=n.dataIdMap.get(l.dataId).id,p=Le(d,c,s,r,u,i),{pSelectedIndices:m,selectedSize:f,pSelectedScores:h,pValidOutputs:b}=Pe(n,p);return n.wasm._free(h),[n.makeOutput([f],"int32",m),n.makeOutput([],"int32",b)]}};let Ue;const ze={kernelName:n.NonMaxSuppressionV5,backendName:"wasm",setupFunc:function(e){Ue=e.wasm.cwrap(n.NonMaxSuppressionV5,"number",["number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:t,attrs:a}=e,{iouThreshold:r,maxOutputSize:s,scoreThreshold:u,softNmsSigma:i}=a,{boxes:o,scores:l}=t,d=n.dataIdMap.get(o.dataId).id,c=n.dataIdMap.get(l.dataId).id,p=Ue(d,c,s,r,u,i),{pSelectedIndices:m,selectedSize:f,pSelectedScores:h,pValidOutputs:b}=Pe(n,p);return n.wasm._free(b),[n.makeOutput([f],"int32",m),n.makeOutput([f],"float32",h)]}},qe=p(n.NotEqual,!1,"bool");let je;const Ve={kernelName:n.OneHot,backendName:"wasm",setupFunc:function(e){je=e.wasm.cwrap(n.OneHot,null,["number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:t,attrs:a}=e,{indices:r}=n,{depth:s,onValue:u,offValue:i}=a,o=t.makeOutput([...r.shape,s],"int32"),l=t.dataIdMap.get(o.dataId).id,d=t.dataIdMap.get(r.dataId).id;return je(d,s,u,i,l),o}};const Ge={kernelName:n.OnesLike,backendName:"wasm",kernelFunc:function(e){const{inputs:{x:n},backend:t}=e,a=t.makeOutput(n.shape,n.dtype);return t.typedArrayFromHeap(a).fill(1),a}};const Ke={kernelName:n.Pack,backendName:"wasm",kernelFunc:function(e){const{inputs:t,backend:a,attrs:r}=e,{axis:s}=r;if(1===t.length)return J({inputs:{input:t[0]},backend:a,attrs:{dim:s}});const u=t[0].shape,i=t[0].dtype;return t.forEach(e=>{n.util.assertShapesMatch(u,e.shape,"All tensors passed to stack must have matching shapes"),n.util.assert(i===e.dtype,()=>"All tensors passed to stack must have matching dtypes")}),D({inputs:t.map(e=>J({inputs:{input:e},backend:a,attrs:{dim:s}})),backend:a,attrs:{axis:s}})}};let Xe;const $e={kernelName:n.PadV2,backendName:"wasm",kernelFunc:function(e){const{inputs:{x:n},backend:t,attrs:{paddings:a,constantValue:r}}=e,s=a.map((e,t)=>e[0]+n.shape[t]+e[1]),i=t.dataIdMap.get(n.dataId).id,o=t.makeOutput(s,n.dtype),l=t.dataIdMap.get(o.dataId).id,d=new Uint8Array(new Int32Array(n.shape).buffer),c=a.map(e=>e[0]),p=a.map(e=>e[1]),m=new Uint8Array(new Int32Array(c).buffer),f=new Uint8Array(new Int32Array(p).buffer);return Xe(i,d,n.shape.length,u[n.dtype],m,f,r,l),o},setupFunc:function(e){Xe=e.wasm.cwrap(n.PadV2,null,["number","array","number","number","array","array","number","number"])}},Ye=p(n.Pow,!1);let Qe;const Ze={kernelName:n.Prelu,backendName:"wasm",setupFunc:function(e){Qe=e.wasm.cwrap(n.Prelu,null,["number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:t}=e,{x:a,alpha:r}=n,s=t.dataIdMap.get(a.dataId).id,u=t.dataIdMap.get(r.dataId).id,i=t.makeOutput(a.shape,"float32"),o=t.dataIdMap.get(i.dataId).id;return Qe(s,u,o),i}};let Je;const en={kernelName:n.Prod,backendName:"wasm",setupFunc:function(e){Je=e.wasm.cwrap(n.Prod,null,["number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{axis:s,keepDims:i}=r,{x:o}=a,l=t.dataIdMap.get(o.dataId).id;let d=l,c=o;const{transposed:p,axes:m,originalAxes:f,inputWasTransposed:h}=k(o,s,t);let b=m;if(h){const e=t.dataIdMap.get(p.dataId).id;e!==l&&(c=p,d=e,b=n.backend_util.getInnerMostAxes(b.length,c.shape.length))}n.backend_util.assertAxesAreInnerMostDims("prod",b,c.shape.length);const[_,y]=n.backend_util.computeOutAndReduceShapes(c.shape,b),g=n.util.sizeFromShape(y),w=t.makeOutput(_,c.dtype);if(0!==n.util.sizeFromShape(c.shape)){const e=t.dataIdMap.get(w.dataId).id;Je(d,g,u[w.dtype],e)}if(h&&t.disposeData(p.dataId),i){const e=n.backend_util.expandShapeToKeepDim(w.shape,f);w.shape=e}return w}},nn={kernelName:n.Range,backendName:"wasm",kernelFunc:e=>{const{backend:t,attrs:a}=e,{start:r,stop:s,step:u,dtype:i}=a,o=function(e,t,a,r){if(e===t||e<t&&a<0||t<e&&a>1)return n.util.makeZerosTypedArray(0,r);const s=Math.abs(Math.ceil((t-e)/a)),u=n.util.makeZerosTypedArray(s,r);t<e&&1===a&&(a=-1),u[0]=e;for(let e=1;e<u.length;e++)u[e]=u[e-1]+a;return u}(r,s,u,i),l=t.makeOutput([o.length],i);return t.typedArrayFromHeap(l).set(o),l}},tn=p(n.RealDiv,!0),an=d(n.Relu),rn=d(n.Relu6);let sn;const un={kernelName:n.ResizeBilinear,backendName:"wasm",setupFunc:function(e){sn=e.wasm.cwrap(n.ResizeBilinear,null,["number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{images:s}=a,{alignCorners:u,halfPixelCenters:i,size:o}=r,[l,d]=o,[c,p,m,f]=s.shape,h=[c,l,d,f];let b,_=t.dataIdMap.get(s.dataId);"float32"!==_.dtype&&(b=F({backend:t,inputs:{x:s},attrs:{dtype:"float32"}}),_=t.dataIdMap.get(b.dataId));const y=_.id,g=t.makeOutput(h,"float32");if(0===n.util.sizeFromShape(s.shape))return g;const w=t.dataIdMap.get(g.dataId).id;return sn(y,c,p,m,f,l,d,u?1:0,i?1:0,w),null!=b&&t.disposeData(b.dataId),g}};let on;const ln={kernelName:n.Reverse,backendName:"wasm",kernelFunc:function(e){const{inputs:t,backend:a,attrs:r}=e,{x:s}=t,{dims:u}=r,i=n.util.parseAxisParam(u,s.shape);if(0===s.shape.length)return b({inputs:{x:s},backend:a});const o=a.makeOutput(s.shape,s.dtype),l=a.dataIdMap.get(s.dataId).id,d=a.dataIdMap.get(o.dataId).id,c=new Uint8Array(new Int32Array(i).buffer),p=new Uint8Array(new Int32Array(s.shape).buffer);return on(l,c,i.length,p,s.shape.length,d),A({inputs:{x:o},attrs:{shape:s.shape},backend:a})},setupFunc:function(e){on=e.wasm.cwrap(n.Reverse,null,["number","array","number","array","number","number"])}};let dn;const cn={kernelName:n.RotateWithOffset,backendName:"wasm",kernelFunc:function(e){const{inputs:t,backend:a,attrs:r}=e,{image:s}=t,{radians:u,fillValue:i,center:o}=r,l=a.makeOutput(s.shape,s.dtype),d=a.dataIdMap.get(s.dataId).id,c=a.dataIdMap.get(l.dataId).id,[p,m,f,h]=s.shape,[b,_]=n.backend_util.getImageCenter(o,m,f),y="number"==typeof i?[i,i,i,0===i?0:255]:[...i,255],g=new Uint8Array(new Int32Array(y).buffer);return dn(d,p,m,f,h,u,b,_,g,y.length,c),l},setupFunc:function(e){dn=e.wasm.cwrap(n.RotateWithOffset,null,["number","number","number","number","number","number","number","number","array","number","number"])}},pn=d(n.Round);let mn;let fn;let hn;function bn(e){const{inputs:{x:t},attrs:{begin:a,size:r},backend:s}=e,[u,i]=n.slice_util.parseSliceParams(t,a,r),o=n.slice_util.isSliceContinous(t.shape,u,i),l=s.readSync(t.dataId),d=s.makeOutput(i,t.dtype),c=n.util.computeStrides(t.shape),p=s.dataIdMap.get(d.dataId);if(o){const e=n.slice_util.computeFlatOffset(u,c);if("string"===t.dtype)p.stringBytes=l.slice(e,e+n.util.sizeFromShape(i));else{s.typedArrayFromHeap(d).set(l.subarray(e,e+n.util.sizeFromShape(i)))}return d}if("string"===t.dtype){const e=R(l,u,i,t.shape,t.dtype);return p.stringBytes=e,d}const m=s.typedArrayFromHeap(d),f=t.shape.length;if(2===f)!function(e,n,t,a,r){let s=0;const u=a[0],i=a[1],o=u+r[0];for(let a=u;a<o;a++){const u=a*n+i;t.set(e.subarray(u,u+r[1]),s),s+=r[1]}}(l,c[0],m,u,i);else if(3===f)!function(e,n,t,a,r,s){let u=0;const i=r[0],o=r[1],l=r[2],d=i+s[0],c=o+s[1];for(let r=i;r<d;r++)for(let i=o;i<c;i++){const o=r*n+i*t+l;a.set(e.subarray(o,o+s[2]),u),u+=s[2]}}(l,c[0],c[1],m,u,i);else if(4===f)!function(e,n,t,a,r,s,u){let i=0;const o=s[0],l=s[1],d=s[2],c=o+u[0],p=l+u[1],m=d+u[2],f=s[3];for(let s=o;s<c;s++)for(let o=l;o<p;o++)for(let l=d;l<m;l++){const d=s*n+o*t+l*a+f;r.set(e.subarray(d,d+u[3]),i),i+=u[3]}}(l,c[0],c[1],c[2],m,u,i);else{const e=R(l,u,i,t.shape,t.dtype);m.set(e)}return d}let _n;let yn;let gn;let wn;let kn;let In;const vn=[c,m,h,v,E,N,T,C,P,B,H,U,j,G,X,Y,Q,Z,ee,ne,ae,re,se,l,ie,le,ce,me,he,be,_e,_,ge,we,ke,Ie,ve,Ee,Ae,xe,Fe,Oe,Ce,Re,De,Be,He,ze,qe,Ve,Ge,Ke,$e,Ye,Ze,en,nn,tn,an,rn,M,un,ln,cn,d(n.Rsqrt),pn,{kernelName:n.ScatterNd,backendName:"wasm",setupFunc:function(e){mn=e.wasm.cwrap(n.ScatterNd,null,["number","number","number","number","number","number","array","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{indices:s,updates:i}=a,{shape:o}=r,l=t.makeOutput(o,i.dtype);if(0===n.util.sizeFromShape(o))return l;const{sliceRank:d,numUpdates:c,sliceSize:p,strides:m,outputSize:f}=n.scatter_util.calculateShapes(i,s,o),h=t.dataIdMap.get(s.dataId).id,b=t.dataIdMap.get(i.dataId).id,_=new Uint8Array(new Int32Array(m).buffer),y=t.dataIdMap.get(l.dataId).id;return mn(h,b,u[i.dtype],d,c,p,_,f,y),l}},{kernelName:n.Select,backendName:"wasm",kernelFunc:function(e){const{inputs:t,backend:a}=e,{condition:r,t:s,e:u}=t,i=a.dataIdMap.get(r.dataId).id,o=a.dataIdMap.get(s.dataId).id,l=a.dataIdMap.get(u.dataId).id,d=a.makeOutput(s.shape,s.dtype),c=a.dataIdMap.get(d.dataId).id,p=r.shape.length,m=s.shape.length,f=0===p||p>1||1===m?1:n.util.sizeFromShape(s.shape.slice(1));return fn(i,o,l,f,c),d},setupFunc:function(e){fn=e.wasm.cwrap("SelectV2",null,["number","number","number","number","number"])}},{kernelName:"Sigmoid",backendName:"wasm",setupFunc:function(e){hn=e.wasm.cwrap(n.Sigmoid,null,["number","number"])},kernelFunc:function(e){const{backend:t,inputs:{x:a}}=e,r=t.dataIdMap.get(a.dataId).id,s=t.makeOutput(a.shape,a.dtype),u=t.dataIdMap.get(s.dataId).id;return 0===n.util.sizeFromShape(s.shape)||hn(r,u),s}},d(n.Sin),{kernelName:n.Slice,backendName:"wasm",kernelFunc:bn},{kernelName:n.Softmax,backendName:"wasm",setupFunc:function(e){_n=e.wasm.cwrap(n.Softmax,null,["number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:{logits:a},attrs:{dim:r}}=e,s=t.dataIdMap.get(a.dataId).id,u=t.makeOutput(a.shape,a.dtype),i=t.dataIdMap.get(u.dataId).id,o=a.shape[r],l=n.util.sizeFromShape(a.shape)/o;return 0===n.util.sizeFromShape(u.shape)||_n(s,i,o,l),u}},{kernelName:n.SplitV,backendName:"wasm",kernelFunc:function(e){const{inputs:t,attrs:a,backend:r}=e,{x:s}=t,{numOrSizeSplits:u,axis:i}=a,o=n.util.parseAxisParam(i,s.shape)[0],l=n.backend_util.prepareSplitSize(s,u,o),d=new Array(s.shape.length).fill(0),c=s.shape.slice();return l.map(e=>{const n=[...c];n[o]=e;const t=bn({inputs:{x:s},attrs:{begin:d,size:n},backend:r});return d[o]+=e,t})}},d(n.Sqrt),d(n.Square),p(n.SquaredDifference,!0),{kernelName:n.Step,backendName:"wasm",setupFunc:function(e){yn=e.wasm.cwrap(n.Step,null,["number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:t,attrs:a}=e,{alpha:r}=a,{x:s}=t,u=n.dataIdMap.get(s.dataId).id,i=n.makeOutput(s.shape,s.dtype),o=n.dataIdMap.get(i.dataId).id;return yn(u,r,o),i}},{kernelName:n.StridedSlice,backendName:"wasm",setupFunc:function(e){gn=e.wasm.cwrap(n.StridedSlice,null,["number","array","number","array","array","array","array","array","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{x:s}=a;let{begin:u,end:i,strides:o}=r;null==o&&(o=new Array(u.length));const{beginMask:l,endMask:d,ellipsisMask:c,newAxisMask:p,shrinkAxisMask:m}=r,f=n.backend_util.slice_util.maskToAxes(c);if(f.length>1)throw new Error("Multiple ellipses in slice is not allowed.");if(0!==c&&0!==p)throw new Error("Using both ellipsisMask and newAxisMask is not yet supported.");if(0!==c&&0!==m)throw new Error("Using both ellipsisMask and shrinkAxisMask is not yet supported.");const h=s.shape.length-u.length,b=n.backend_util.slice_util.maskToAxes(p),_=s.shape.slice();b.forEach(e=>{u[e]=0,i[e]=1,_.splice(e,0,1)});const y=A({inputs:{x:s},attrs:{shape:_},backend:t}),{begin:g,end:w,strides:k}=n.backend_util.slice_util.getNormalizedAxes(y.shape,f,h,u,i,o,l,d,c);u=g,i=w,o=k;const I=n.backend_util.slice_util.maskToAxes(m);I.forEach(e=>{i[e]=u[e]+1,o[e]=1});const v=n.backend_util.slice_util.computeOutShape(u,i,o),S=v.filter((e,n)=>-1===I.indexOf(n));if(o.every(e=>1===e)){return A({inputs:{x:bn({inputs:{x:s},attrs:{begin:u,size:v},backend:t})},attrs:{shape:S},backend:t})}const E=t.makeOutput(S,"float32");if(!S.some(e=>0===e)){const e=t.dataIdMap.get(y.dataId).id,a=new Uint8Array(new Int32Array(n.util.computeStrides(y.shape)).buffer),r=new Uint8Array(new Int32Array(u).buffer),s=new Uint8Array(new Int32Array(i).buffer),l=new Uint8Array(new Int32Array(o).buffer),d=new Uint8Array(new Int32Array(S).buffer),c=new Uint8Array(new Int32Array(n.util.computeStrides(S)).buffer),p=t.dataIdMap.get(E.dataId).id;gn(e,a,y.shape.length,r,s,l,d,c,S.length,p)}return A({inputs:{x:E},attrs:{shape:S},backend:t})}},p(n.Sub,!0),{kernelName:n.Sum,backendName:"wasm",setupFunc:function(e){wn=e.wasm.cwrap(n.Sum,null,["number, number, number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{axis:s,keepDims:u}=r,{x:i}=a,o=t.dataIdMap.get(i.dataId).id;let l=o,d=i;const{transposed:c,axes:p,originalAxes:m,inputWasTransposed:f}=k(i,s,t);let h=p;if(f){const e=t.dataIdMap.get(c.dataId).id;e!==o&&(d=c,l=e,h=n.backend_util.getInnerMostAxes(h.length,d.shape.length))}n.backend_util.assertAxesAreInnerMostDims("sum",h,d.shape.length);const[b,_]=n.backend_util.computeOutAndReduceShapes(d.shape,h),y=n.util.sizeFromShape(_),g=t.makeOutput(b,d.dtype);if(0!==n.util.sizeFromShape(d.shape)){const e=t.dataIdMap.get(g.dataId).id;wn(l,y,e)}if(f&&t.disposeData(c.dataId),u){const e=n.backend_util.expandShapeToKeepDim(g.shape,m);g.shape=e}return g}},d(n.Tanh),{kernelName:n.Tile,backendName:"wasm",setupFunc:function(e){kn=e.wasm.cwrap(n.Tile,null,["number","array","number","array","number","number"])},kernelFunc:function(e){const{inputs:n,backend:t,attrs:a}=e,{x:r}=n,s=t.dataIdMap.get(r.dataId).id,{reps:i}=a,o=new Array(r.shape.length);for(let e=0;e<o.length;e++)o[e]=r.shape[e]*i[e];const l=new Uint8Array(new Int32Array(r.shape).buffer),d=new Uint8Array(new Int32Array(o).buffer),c=t.makeOutput(o,r.dtype),p=t.dataIdMap.get(c.dataId).id;return kn(s,l,r.shape.length,d,o.length,u[c.dtype],p),c}},{kernelName:n.TopK,backendName:"wasm",setupFunc:function(e){In=e.wasm.cwrap(n.TopK,null,["number","array","number","number","number","bool","number","number"])},kernelFunc:({inputs:e,backend:n,attrs:t})=>{const{x:a}=e,{k:r,sorted:s}=t,i=n.dataIdMap.get(a.dataId).id,o=new Uint8Array(new Int32Array(a.shape).buffer),l=a.shape.slice();l[l.length-1]=r;const d=n.makeOutput(l,a.dtype),c=n.dataIdMap.get(d.dataId).id,p=n.makeOutput(l,"int32"),m=n.dataIdMap.get(p.dataId).id;return In(i,o,a.shape.length,u[a.dtype],r,s,c,m),[d,p]}},w,{kernelName:n.Unpack,backendName:"wasm",kernelFunc:function(e){const{inputs:n,backend:t,attrs:a}=e,{value:r}=n;let{axis:s}=a;s<0&&(s+=r.shape.length);const u=r.shape[s],i=r.shape.length,o=new Array(i-1);let l=0;for(let e=0;e<i;e++)e!==s&&(o[l++]=r.shape[e]);const d=new Array(u),c=new Array(i).fill(0),p=r.shape.slice();p[s]=1;for(let e=0;e<d.length;e++)c[s]=e,d[e]=bn({inputs:{x:r},attrs:{begin:c,size:p},backend:t});return d.map(({dataId:e,dtype:n})=>({dataId:e,dtype:n,shape:o}))}},{kernelName:n.ZerosLike,backendName:"wasm",kernelFunc:function(e){const{inputs:{x:n},backend:t}=e,a=t.makeOutput(n.shape,n.dtype);return t.typedArrayFromHeap(a).fill(0),a}}];for(const e of vn)n.registerKernel(e);const Sn=n.env();function En(e,n){return e(n={exports:{}},n.exports),n.exports}Sn.registerFlag("WASM_HAS_SIMD_SUPPORT",async()=>WebAssembly.validate(new Uint8Array([0,97,115,109,1,0,0,0,1,4,1,96,0,0,3,2,1,0,10,9,1,7,0,65,0,253,15,26,11]))),Sn.registerFlag("WASM_HAS_MULTITHREAD_SUPPORT",async()=>{if(Sn.get("IS_NODE"))return!1;try{return(new MessageChannel).port1.postMessage(new SharedArrayBuffer(1)),WebAssembly.validate(new Uint8Array([0,97,115,109,1,0,0,0,1,4,1,96,0,0,3,2,1,0,5,4,1,3,1,1,10,11,1,9,0,65,0,254,16,2,0,26,11]))}catch(e){return!1}});var An=En((function(e,n){var u,i=(u="undefined"!=typeof document&&document.currentScript?document.currentScript.src:void 0,"undefined"!=typeof __filename&&(u=u||__filename),function(e){function n(){return x.buffer!=V&&J(x.buffer),G}function i(){return x.buffer!=V&&J(x.buffer),K}function o(){return x.buffer!=V&&J(x.buffer),X}function l(){return x.buffer!=V&&J(x.buffer),$}function d(){return x.buffer!=V&&J(x.buffer),Y}var c,p=void 0!==(e=e||{})?e:{},m={};for(c in p)p.hasOwnProperty(c)&&(m[c]=p[c]);var f=!1,h=!1,b=!1,_=!1;f="object"==typeof window,h="function"==typeof importScripts,b="object"==typeof process&&"object"==typeof process.versions&&"string"==typeof process.versions.node,_=!f&&!b&&!h;var y=p.ENVIRONMENT_IS_PTHREAD||!1;y&&(V=p.buffer,ee=p.DYNAMIC_BASE,ne=p.DYNAMICTOP_PTR);var g,w,k,I,v="";function S(e){return p.locateFile?p.locateFile(e,v):v+e}if(b){var E;v=h?t.dirname(v)+"/":__dirname+"/",g=function(e,n){return k||(k=a),I||(I=t),e=I.normalize(e),k.readFileSync(e,n?null:"utf8")},w=function(e){var n=g(e,!0);return n.buffer||(n=new Uint8Array(n)),D(n.buffer),n},process.argv.length>1&&process.argv[1].replace(/\\/g,"/"),process.argv.slice(2),process.on("uncaughtException",(function(e){if(!(e instanceof pt))throw e})),process.on("unhandledRejection",ke),p.inspect=function(){return"[Emscripten Module object]"};try{E=r}catch(e){throw console.error('The "worker_threads" module is not supported in this node.js build - perhaps a newer version is needed?'),e}Worker=E.Worker}else _?("undefined"!=typeof read&&(g=function(e){return read(e)}),w=function(e){var n;return"function"==typeof readbuffer?new Uint8Array(readbuffer(e)):(D("object"==typeof(n=read(e,"binary"))),n)},"undefined"!=typeof scriptArgs&&scriptArgs,"undefined"!=typeof print&&("undefined"==typeof console&&(console={}),console.log=print,console.warn=console.error="undefined"!=typeof printErr?printErr:print)):(f||h)&&(h?v=self.location.href:document.currentScript&&(v=document.currentScript.src),u&&(v=u),v=0!==v.indexOf("blob:")?v.substr(0,v.lastIndexOf("/")+1):"",b?(g=function(e,n){return k||(k=a),I||(I=t),e=I.normalize(e),k.readFileSync(e,n?null:"utf8")},w=function(e){var n=g(e,!0);return n.buffer||(n=new Uint8Array(n)),D(n.buffer),n}):(g=function(e){var n=new XMLHttpRequest;return n.open("GET",e,!1),n.send(null),n.responseText},h&&(w=function(e){var n=new XMLHttpRequest;return n.open("GET",e,!1),n.responseType="arraybuffer",n.send(null),new Uint8Array(n.response)})));b&&"undefined"==typeof performance&&(performance=s.performance);var A,M,x,N=p.print||console.log.bind(console),F=p.printErr||console.warn.bind(console);for(c in m)m.hasOwnProperty(c)&&(p[c]=m[c]);m=null,p.arguments&&p.arguments,p.thisProgram&&p.thisProgram,p.quit&&p.quit,p.wasmBinary&&(A=p.wasmBinary),p.noExitRuntime&&(M=p.noExitRuntime),"object"!=typeof WebAssembly&&F("no native wasm support detected");var T,O=new WebAssembly.Table({initial:169,maximum:169,element:"anyfunc"}),C=0,R=!1;function D(e,n){e||ke("Assertion failed: "+n)}function P(e){var n=p["_"+e];return D(n,"Cannot call unknown function "+e+", make sure it is exported"),n}function W(e,n,t,a,r){var s={string:function(e){var n=0;if(null!=e&&0!==e){var t=1+(e.length<<2);z(e,n=lt(t),t)}return n},array:function(e){var n=lt(e.length);return j(e,n),n}},u=P(e),i=[],o=0;if(a)for(var l=0;l<a.length;l++){var d=s[t[l]];d?(0===o&&(o=ot()),i[l]=d(a[l])):i[l]=a[l]}var c=u.apply(null,i);return c=function(e){return"string"===n?H(e):"boolean"===n?Boolean(e):e}(c),0!==o&&dt(o),c}function B(e,n,t,a){var r=(t=t||[]).every((function(e){return"number"===e}));return"string"!==n&&r&&!a?P(e):function(){return W(e,n,t,arguments)}}function L(e,n,t){for(var a=n+t,r="";!(n>=a);){var s=e[n++];if(!s)return r;if(128&s){var u=63&e[n++];if(192!=(224&s)){var i=63&e[n++];if((s=224==(240&s)?(15&s)<<12|u<<6|i:(7&s)<<18|u<<12|i<<6|63&e[n++])<65536)r+=String.fromCharCode(s);else{var o=s-65536;r+=String.fromCharCode(55296|o>>10,56320|1023&o)}}else r+=String.fromCharCode((31&s)<<6|u)}else r+=String.fromCharCode(s)}return r}function H(e,n){return e?L(i(),e,n):""}function U(e,n,t,a){if(!(a>0))return 0;for(var r=t,s=t+a-1,u=0;u<e.length;++u){var i=e.charCodeAt(u);if(i>=55296&&i<=57343&&(i=65536+((1023&i)<<10)|1023&e.charCodeAt(++u)),i<=127){if(t>=s)break;n[t++]=i}else if(i<=2047){if(t+1>=s)break;n[t++]=192|i>>6,n[t++]=128|63&i}else if(i<=65535){if(t+2>=s)break;n[t++]=224|i>>12,n[t++]=128|i>>6&63,n[t++]=128|63&i}else{if(t+3>=s)break;n[t++]=240|i>>18,n[t++]=128|i>>12&63,n[t++]=128|i>>6&63,n[t++]=128|63&i}}return n[t]=0,t-r}function z(e,n,t){return U(e,i(),n,t)}function q(e){for(var n=0,t=0;t<e.length;++t){var a=e.charCodeAt(t);a>=55296&&a<=57343&&(a=65536+((1023&a)<<10)|1023&e.charCodeAt(++t)),a<=127?++n:n+=a<=2047?2:a<=65535?3:4}return n}function j(e,t){n().set(e,t)}var V,G,K,X,$,Y,Q=65536;function Z(e,n){return e%n>0&&(e+=n-e%n),e}function J(e){V=e,p.HEAP8=G=new Int8Array(e),p.HEAP16=new Int16Array(e),p.HEAP32=X=new Int32Array(e),p.HEAPU8=K=new Uint8Array(e),p.HEAPU16=new Uint16Array(e),p.HEAPU32=$=new Uint32Array(e),p.HEAPF32=new Float32Array(e),p.HEAPF64=Y=new Float64Array(e)}var ee=5256464,ne=12656,te=p.INITIAL_MEMORY||16777216;if(y)x=p.wasmMemory,V=p.buffer;else if(p.wasmMemory)x=p.wasmMemory;else if(!((x=new WebAssembly.Memory({initial:te/Q,maximum:2147483648/Q,shared:!0})).buffer instanceof SharedArrayBuffer))throw F("requested a shared WebAssembly.Memory but the returned buffer is not a SharedArrayBuffer, indicating that while the browser has SharedArrayBuffer it does not have WebAssembly threads support - you may need to set a flag"),b&&console.log("(on node you may need: --experimental-wasm-threads --experimental-wasm-bulk-memory and also use a recent version)"),Error("bad memory");function ae(e){for(;e.length>0;){var n=e.shift();if("function"!=typeof n){var t=n.func;"number"==typeof t?void 0===n.arg?p.dynCall_v(t):p.dynCall_vi(t,n.arg):t(void 0===n.arg?null:n.arg)}else n(p)}}x&&(V=x.buffer),te=V.byteLength,J(V),y||(o()[ne>>2]=ee);var re=[],se=[],ue=[],ie=[];function oe(){if(!y){if(p.preRun)for("function"==typeof p.preRun&&(p.preRun=[p.preRun]);p.preRun.length;)pe(p.preRun.shift());ae(re)}}function le(){ae(se)}function de(){y||ae(ue)}function ce(){if(!y){if(p.postRun)for("function"==typeof p.postRun&&(p.postRun=[p.postRun]);p.postRun.length;)me(p.postRun.shift());ae(ie)}}function pe(e){re.unshift(e)}function me(e){ie.unshift(e)}var fe=Math.ceil,he=Math.floor,be=0,_e=null,ye=null;function ge(e){D(!y,"addRunDependency cannot be used in a pthread worker"),be++,p.monitorRunDependencies&&p.monitorRunDependencies(be)}function we(e){if(be--,p.monitorRunDependencies&&p.monitorRunDependencies(be),0==be&&(null!==_e&&(clearInterval(_e),_e=null),ye)){var n=ye;ye=null,n()}}function ke(e){throw p.onAbort&&p.onAbort(e),y&&console.error("Pthread aborting at "+(new Error).stack),N(e+=""),F(e),R=!0,e="abort("+e+"). Build with -s ASSERTIONS=1 for more info.",new WebAssembly.RuntimeError(e)}function Ie(e,n){return String.prototype.startsWith?e.startsWith(n):0===e.indexOf(n)}p.preloadedImages={},p.preloadedAudios={};var ve="data:application/octet-stream;base64,";function Se(e){return Ie(e,ve)}var Ee="file://";function Ae(e){return Ie(e,Ee)}var Me="tfjs-backend-wasm-threaded-simd.wasm";function xe(){try{if(A)return new Uint8Array(A);if(w)return w(Me);throw"both async and sync fetching of the wasm failed"}catch(e){ke(e)}}function Ne(){return A||!f&&!h||"function"!=typeof fetch||Ae(Me)?new Promise((function(e,n){e(xe())})):fetch(Me,{credentials:"same-origin"}).then((function(e){if(!e.ok)throw"failed to load wasm binary file at '"+Me+"'";return e.arrayBuffer()})).catch((function(){return xe()}))}function Fe(){var e={a:Kn};function n(e,n){var t=e.exports;if(p.asm=t,T=n,!y){var a=je.unusedWorkers.length;je.unusedWorkers.forEach((function(e){je.loadWasmModuleToWorker(e,(function(){--a||we()}))}))}}function t(e){n(e.instance,e.module)}function a(n){return Ne().then((function(n){return WebAssembly.instantiate(n,e)})).then(n,(function(e){F("failed to asynchronously prepare wasm: "+e),ke(e)}))}if(y||ge(),p.instantiateWasm)try{return p.instantiateWasm(e,n)}catch(e){return F("Module.instantiateWasm callback failed with error: "+e),!1}return function(){if(A||"function"!=typeof WebAssembly.instantiateStreaming||Se(Me)||Ae(Me)||"function"!=typeof fetch)return a(t);fetch(Me,{credentials:"same-origin"}).then((function(n){return WebAssembly.instantiateStreaming(n,e).then(t,(function(e){F("wasm streaming compile failed: "+e),F("falling back to ArrayBuffer instantiation"),a(t)}))}))}(),{}}Se(Me)||(Me=S(Me));var Te={};function Oe(){je.initRuntime()}y||se.push({func:function(){Yn()}});var Ce=0,Re=0,De=0;function Pe(e,n,t){Ce=e|=0,De=n|=0,Re=t|=0}p.__register_pthread_ptr=Pe;var We={EPERM:63,ENOENT:44,ESRCH:71,EINTR:27,EIO:29,ENXIO:60,E2BIG:1,ENOEXEC:45,EBADF:8,ECHILD:12,EAGAIN:6,EWOULDBLOCK:6,ENOMEM:48,EACCES:2,EFAULT:21,ENOTBLK:105,EBUSY:10,EEXIST:20,EXDEV:75,ENODEV:43,ENOTDIR:54,EISDIR:31,EINVAL:28,ENFILE:41,EMFILE:33,ENOTTY:59,ETXTBSY:74,EFBIG:22,ENOSPC:51,ESPIPE:70,EROFS:69,EMLINK:34,EPIPE:64,EDOM:18,ERANGE:68,ENOMSG:49,EIDRM:24,ECHRNG:106,EL2NSYNC:156,EL3HLT:107,EL3RST:108,ELNRNG:109,EUNATCH:110,ENOCSI:111,EL2HLT:112,EDEADLK:16,ENOLCK:46,EBADE:113,EBADR:114,EXFULL:115,ENOANO:104,EBADRQC:103,EBADSLT:102,EDEADLOCK:16,EBFONT:101,ENOSTR:100,ENODATA:116,ETIME:117,ENOSR:118,ENONET:119,ENOPKG:120,EREMOTE:121,ENOLINK:47,EADV:122,ESRMNT:123,ECOMM:124,EPROTO:65,EMULTIHOP:36,EDOTDOT:125,EBADMSG:9,ENOTUNIQ:126,EBADFD:127,EREMCHG:128,ELIBACC:129,ELIBBAD:130,ELIBSCN:131,ELIBMAX:132,ELIBEXEC:133,ENOSYS:52,ENOTEMPTY:55,ENAMETOOLONG:37,ELOOP:32,EOPNOTSUPP:138,EPFNOSUPPORT:139,ECONNRESET:15,ENOBUFS:42,EAFNOSUPPORT:5,EPROTOTYPE:67,ENOTSOCK:57,ENOPROTOOPT:50,ESHUTDOWN:140,ECONNREFUSED:14,EADDRINUSE:3,ECONNABORTED:13,ENETUNREACH:40,ENETDOWN:38,ETIMEDOUT:73,EHOSTDOWN:142,EHOSTUNREACH:23,EINPROGRESS:26,EALREADY:7,EDESTADDRREQ:17,EMSGSIZE:35,EPROTONOSUPPORT:66,ESOCKTNOSUPPORT:137,EADDRNOTAVAIL:4,ENETRESET:39,EISCONN:30,ENOTCONN:53,ETOOMANYREFS:141,EUSERS:136,EDQUOT:19,ESTALE:72,ENOTSUP:138,ENOMEDIUM:148,EILSEQ:25,EOVERFLOW:61,ECANCELED:11,ENOTRECOVERABLE:56,EOWNERDEAD:62,ESTRPIPE:135},Be=13568;function Le(e,t){if(e<=0||e>n().length||!0&e||t<0)return-28;if(0==t)return 0;t>=2147483647&&(t=1/0);var a=Atomics.load(o(),Be>>2),r=0;if(a==e&&Atomics.compareExchange(o(),Be>>2,a,0)==a&&(r=1,--t<=0))return 1;var s=Atomics.notify(o(),e>>2,t);if(s>=0)return s+r;throw"Atomics.notify returned an unexpected value "+s}function He(e){if(y)throw"Internal Error! _kill_thread() can only ever be called from main application thread!";if(!e)throw"Internal Error! Null pthread_ptr in _kill_thread!";o()[e+12>>2]=0;var n=je.pthreads[e];n.worker.terminate(),je.freeThreadData(n),je.runningWorkers.splice(je.runningWorkers.indexOf(n.worker),1),n.worker.pthread=void 0}function Ue(e){if(y)throw"Internal Error! _cancel_thread() can only ever be called from main application thread!";if(!e)throw"Internal Error! Null pthread_ptr in _cancel_thread!";je.pthreads[e].worker.postMessage({cmd:"cancel"})}function ze(e){if(y)throw"Internal Error! _cleanup_thread() can only ever be called from main application thread!";if(!e)throw"Internal Error! Null pthread_ptr in _cleanup_thread!";o()[e+12>>2]=0;var n=je.pthreads[e];if(n){var t=n.worker;je.returnWorkerToPool(t)}}p._emscripten_futex_wake=Le;var qe,je={MAIN_THREAD_ID:1,mainThreadInfo:{schedPolicy:0,schedPrio:0},unusedWorkers:[],runningWorkers:[],initRuntime:function(){Pe(je.mainThreadBlock,!h,1),rt(je.mainThreadBlock)},initMainThreadBlock:function(){for(var e=0;e<8;++e)je.allocateUnusedWorker();for(je.mainThreadBlock=12816,e=0;e<58;++e)l()[je.mainThreadBlock/4+e]=0;o()[je.mainThreadBlock+12>>2]=je.mainThreadBlock;var n=je.mainThreadBlock+156;for(o()[n>>2]=n,e=0;e<128;++e)l()[3264+e]=0;Atomics.store(l(),je.mainThreadBlock+104>>2,13056),Atomics.store(l(),je.mainThreadBlock+40>>2,je.mainThreadBlock),Atomics.store(l(),je.mainThreadBlock+44>>2,42)},initWorker:function(){},pthreads:{},exitHandlers:null,setThreadStatus:function(){},runExitHandlers:function(){if(null!==je.exitHandlers){for(;je.exitHandlers.length>0;)je.exitHandlers.pop()();je.exitHandlers=null}y&&C&&tt()},threadExit:function(e){var n=zn();n&&(Atomics.store(l(),n+4>>2,e),Atomics.store(l(),n+0>>2,1),Atomics.store(l(),n+60>>2,1),Atomics.store(l(),n+64>>2,0),je.runExitHandlers(),Le(n+0,2147483647),Pe(0,0,0),C=0,y&&postMessage({cmd:"exit"}))},threadCancel:function(){je.runExitHandlers(),Atomics.store(l(),C+4>>2,-1),Atomics.store(l(),C+0>>2,1),Le(C+0,2147483647),C=0,Pe(0,0,0),postMessage({cmd:"cancelDone"})},terminateAllThreads:function(){for(var e in je.pthreads)(a=je.pthreads[e])&&a.worker&&je.returnWorkerToPool(a.worker);je.pthreads={};for(var n=0;n<je.unusedWorkers.length;++n)(t=je.unusedWorkers[n]).terminate();for(je.unusedWorkers=[],n=0;n<je.runningWorkers.length;++n){var t,a=(t=je.runningWorkers[n]).pthread;je.freeThreadData(a),t.terminate()}je.runningWorkers=[]},freeThreadData:function(e){if(e){if(e.threadInfoStruct){var n=o()[e.threadInfoStruct+104>>2];o()[e.threadInfoStruct+104>>2]=0,Zn(n),Zn(e.threadInfoStruct)}e.threadInfoStruct=0,e.allocatedOwnStack&&e.stackBase&&Zn(e.stackBase),e.stackBase=0,e.worker&&(e.worker.pthread=null)}},returnWorkerToPool:function(e){delete je.pthreads[e.pthread.thread],je.unusedWorkers.push(e),je.runningWorkers.splice(je.runningWorkers.indexOf(e),1),je.freeThreadData(e.pthread),e.pthread=void 0},receiveObjectTransfer:function(e){},loadWasmModuleToWorker:function(e,n){e.onmessage=function(t){var a=t.data,r=a.cmd;if(e.pthread&&(je.currentProxiedOperationCallerThread=e.pthread.threadInfoStruct),a.targetThread&&a.targetThread!=zn()){var s=je.pthreads[a.targetThread];return s?s.worker.postMessage(t.data,a.transferList):console.error('Internal error! Worker sent a message "'+r+'" to target pthread '+a.targetThread+", but that thread no longer exists!"),void(je.currentProxiedOperationCallerThread=void 0)}"processQueuedMainThreadWork"===r?at():"spawnThread"===r?Hn(t.data):"cleanupThread"===r?ze(a.thread):"killThread"===r?He(a.thread):"cancelThread"===r?Ue(a.thread):"loaded"===r?(e.loaded=!0,n&&n(e),e.runPthread&&(e.runPthread(),delete e.runPthread)):"print"===r?N("Thread "+a.threadId+": "+a.text):"printErr"===r?F("Thread "+a.threadId+": "+a.text):"alert"===r?alert("Thread "+a.threadId+": "+a.text):"exit"===r?e.pthread&&Atomics.load(l(),e.pthread.thread+68>>2)&&je.returnWorkerToPool(e):"cancelDone"===r?je.returnWorkerToPool(e):"objectTransfer"===r?je.receiveObjectTransfer(t.data):"setimmediate"===t.data.target?e.postMessage(t.data):F("worker sent an unknown command "+r),je.currentProxiedOperationCallerThread=void 0},e.onerror=function(e){F("pthread sent an error! "+e.filename+":"+e.lineno+": "+e.message)},b&&(e.on("message",(function(n){e.onmessage({data:n})})),e.on("error",(function(n){e.onerror(n)})),e.on("exit",(function(e){console.log("worker exited - TODO: update the worker queue?")}))),e.postMessage({cmd:"load",urlOrBlob:p.mainScriptUrlOrBlob||u,wasmMemory:x,wasmModule:T,DYNAMIC_BASE:ee,DYNAMICTOP_PTR:ne})},allocateUnusedWorker:function(){var e=S("tfjs-backend-wasm-threaded-simd.worker.js");je.unusedWorkers.push(new Worker(e))},getNewWorker:function(){return 0==je.unusedWorkers.length&&(je.allocateUnusedWorker(),je.loadWasmModuleToWorker(je.unusedWorkers[0])),je.unusedWorkers.length>0?je.unusedWorkers.pop():null},busySpinWait:function(e){for(var n=performance.now()+e;performance.now()<n;);}};function Ve(e,n){dt(e)}function Ge(){return M}function Ke(e,n,t,a){ke("Assertion failed: "+H(e)+", at: "+[n?H(n):"unknown filename",t,a?H(a):"unknown function"])}function Xe(e,n){_main(e,n)}function $e(e){return o()[Jn()>>2]=e,e}function Ye(e,n){if(y)return sn(1,1,e,n)}function Qe(e,n){if(e==n)postMessage({cmd:"processQueuedMainThreadWork"});else if(y)postMessage({targetThread:e,cmd:"processThreadQueue"});else{var t=je.pthreads[e],a=t&&t.worker;if(!a)return;a.postMessage({cmd:"processThreadQueue"})}return 1}function Ze(){ke()}function Je(e,n){}function en(e,t,a){if(e<=0||e>n().length||!0&e)return-28;if(h){var r=Atomics.wait(o(),e>>2,t,a);if("timed-out"===r)return-73;if("not-equal"===r)return-6;if("ok"===r)return 0;throw"Atomics.wait returned an unexpected value "+r}if(t!=Atomics.load(o(),e>>2))return-6;var s=performance.now(),u=s+a;Atomics.store(o(),Be>>2,e);for(var i=e;e==i;){if((s=performance.now())>u)return-73;at(),e=Atomics.load(o(),Be>>2)}return 0}function nn(){return 0|De}function tn(){return 0|Re}function an(e,n,t){i().copyWithin(e,n,n+t)}function rn(){return navigator.hardwareConcurrency}function sn(e,n){for(var t=arguments.length-2,a=ot(),r=lt(8*t),s=r>>3,u=0;u<t;u++)d()[s+u]=arguments[2+u];var i=ut(e,t,r,n);return dt(a),i}p.establishStackSpace=Ve,p.getNoExitRuntime=Ge,qe=b?function(){var e=process.hrtime();return 1e3*e[0]+e[1]/1e6}:y?function(){return performance.now()-p.__performance_now_clock_drift}:"undefined"!=typeof dateNow?dateNow:function(){return performance.now()};var un=[];function on(e,n){on.array||(on.array=[]);var t,a=on.array;for(a.length=0;t=i()[e++];)100===t||102===t?(n=n+7&-8,a.push(d()[n>>3]),n+=8):(n=n+3&-4,a.push(o()[n>>2]),n+=4);return a}function ln(e,n,t){un.length=n;for(var a=t>>3,r=0;r<n;r++)un[r]=d()[a+r];var s=e<0,u=s?Te[-e-1]:Gn[e];if(s){var i=on(un[1],un[2]);return u.apply(null,i)}return u.apply(null,un)}function dn(){return i().length}function cn(e){try{return x.grow(e-V.byteLength+65535>>>16),J(x.buffer),1}catch(e){}}function pn(e){e>>>=0;var n=dn();if(e<=n)return!1;if(e>2147483648)return!1;for(var t=1;t<=4;t*=2){var a=n*(1+.2/t);if(a=Math.min(a,e+100663296),cn(Math.min(2147483648,Z(Math.max(16777216,e,a),65536))))return!0}return!1}var mn={keyEvent:0,mouseEvent:0,wheelEvent:0,uiEvent:0,focusEvent:0,deviceOrientationEvent:0,deviceMotionEvent:0,fullscreenChangeEvent:0,pointerlockChangeEvent:0,visibilityChangeEvent:0,touchEvent:0,previousFullscreenElement:null,previousScreenX:null,previousScreenY:null,removeEventListenersRegistered:!1,removeAllEventListeners:function(){for(var e=mn.eventHandlers.length-1;e>=0;--e)mn._removeHandler(e);mn.eventHandlers=[],mn.deferredCalls=[]},registerRemoveEventListeners:function(){mn.removeEventListenersRegistered||(mn.removeEventListenersRegistered=!0)},deferredCalls:[],deferCall:function(e,n,t){function a(e,n){if(e.length!=n.length)return!1;for(var t in e)if(e[t]!=n[t])return!1;return!0}for(var r in mn.deferredCalls){var s=mn.deferredCalls[r];if(s.targetFunction==e&&a(s.argsList,t))return}mn.deferredCalls.push({targetFunction:e,precedence:n,argsList:t}),mn.deferredCalls.sort((function(e,n){return e.precedence<n.precedence}))},removeDeferredCalls:function(e){for(var n=0;n<mn.deferredCalls.length;++n)mn.deferredCalls[n].targetFunction==e&&(mn.deferredCalls.splice(n,1),--n)},canPerformEventHandlerRequests:function(){return mn.inEventHandler&&mn.currentEventHandler.allowsDeferredCalls},runDeferredCalls:function(){if(mn.canPerformEventHandlerRequests())for(var e=0;e<mn.deferredCalls.length;++e){var n=mn.deferredCalls[e];mn.deferredCalls.splice(e,1),--e,n.targetFunction.apply(null,n.argsList)}},inEventHandler:0,currentEventHandler:null,eventHandlers:[],removeAllHandlersOnTarget:function(e,n){for(var t=0;t<mn.eventHandlers.length;++t)mn.eventHandlers[t].target!=e||n&&n!=mn.eventHandlers[t].eventTypeString||mn._removeHandler(t--)},_removeHandler:function(e){var n=mn.eventHandlers[e];n.target.removeEventListener(n.eventTypeString,n.eventListenerFunc,n.useCapture),mn.eventHandlers.splice(e,1)},registerOrRemoveHandler:function(e){var n=function(n){++mn.inEventHandler,mn.currentEventHandler=e,mn.runDeferredCalls(),e.handlerFunc(n),mn.runDeferredCalls(),--mn.inEventHandler};if(e.callbackfunc)e.eventListenerFunc=n,e.target.addEventListener(e.eventTypeString,n,e.useCapture),mn.eventHandlers.push(e),mn.registerRemoveEventListeners();else for(var t=0;t<mn.eventHandlers.length;++t)mn.eventHandlers[t].target==e.target&&mn.eventHandlers[t].eventTypeString==e.eventTypeString&&mn._removeHandler(t--)},queueEventHandlerOnThread_iiii:function(e,n,t,a,r){var s=ot(),u=lt(12);o()[u>>2]=t,o()[u+4>>2]=a,o()[u+8>>2]=r,it(e,637534208,n,a,u),dt(s)},getTargetThreadForEventCallback:function(e){switch(e){case 1:return 0;case 2:return je.currentProxiedOperationCallerThread;default:return e}},getNodeNameForTarget:function(e){return e?e==window?"#window":e==screen?"#screen":e&&e.nodeName?e.nodeName:"":""},fullscreenEnabled:function(){return document.fullscreenEnabled||document.webkitFullscreenEnabled}};function fn(e){var n=q(e)+1,t=Qn(n);return z(e,t,n),t}function hn(e,n,t,a){var r=ot(),s=lt(12),u=0;n&&(u=fn(n)),o()[s>>2]=u,o()[s+4>>2]=t,o()[s+8>>2]=a,it(e,657457152,0,u,s),dt(r)}function bn(e,n,t,a){hn(e,n=n?H(n):"",t,a)}function _n(e){return e>2?H(e):e}var yn=[0,"undefined"!=typeof document?document:0,"undefined"!=typeof window?window:0];function gn(e){return e=_n(e),yn[e]||("undefined"!=typeof document?document.querySelector(e):void 0)}function wn(e){return gn(e)}function kn(e,n,t){var a=wn(e);if(!a)return-4;if(a.canvasSharedPtr&&(o()[a.canvasSharedPtr>>2]=n,o()[a.canvasSharedPtr+4>>2]=t),!a.offscreenCanvas&&a.controlTransferredOffscreen)return a.canvasSharedPtr?(bn(o()[a.canvasSharedPtr+8>>2],e,n,t),1):-4;a.offscreenCanvas&&(a=a.offscreenCanvas);var r=!1;if(a.GLctxObject&&a.GLctxObject.GLctx){var s=a.GLctxObject.GLctx.getParameter(2978);r=0===s[0]&&0===s[1]&&s[2]===a.width&&s[3]===a.height}return a.width=n,a.height=t,r&&a.GLctxObject.GLctx.viewport(0,0,n,t),0}function In(e,n,t){return y?sn(2,1,e,n,t):kn(e,n,t)}function vn(e,n,t){return wn(e)?kn(e,n,t):In(e,n,t)}function Sn(e){}function En(e,n){}function An(e){var n=e.getExtension("ANGLE_instanced_arrays");if(n)return e.vertexAttribDivisor=function(e,t){n.vertexAttribDivisorANGLE(e,t)},e.drawArraysInstanced=function(e,t,a,r){n.drawArraysInstancedANGLE(e,t,a,r)},e.drawElementsInstanced=function(e,t,a,r,s){n.drawElementsInstancedANGLE(e,t,a,r,s)},1}function Mn(e){var n=e.getExtension("OES_vertex_array_object");if(n)return e.createVertexArray=function(){return n.createVertexArrayOES()},e.deleteVertexArray=function(e){n.deleteVertexArrayOES(e)},e.bindVertexArray=function(e){n.bindVertexArrayOES(e)},e.isVertexArray=function(e){return n.isVertexArrayOES(e)},1}function xn(e){var n=e.getExtension("WEBGL_draw_buffers");if(n)return e.drawBuffers=function(e,t){n.drawBuffersWEBGL(e,t)},1}var Nn={counter:1,lastError:0,buffers:[],mappedBuffers:{},programs:[],framebuffers:[],renderbuffers:[],textures:[],uniforms:[],shaders:[],vaos:[],contexts:{},currentContext:null,offscreenCanvases:{},timerQueriesEXT:[],programInfos:{},stringCache:{},unpackAlignment:4,init:function(){for(var e=new Float32Array(Nn.MINI_TEMP_BUFFER_SIZE),n=0;n<Nn.MINI_TEMP_BUFFER_SIZE;n++)Nn.miniTempBufferFloatViews[n]=e.subarray(0,n+1);var t=new Int32Array(Nn.MINI_TEMP_BUFFER_SIZE);for(n=0;n<Nn.MINI_TEMP_BUFFER_SIZE;n++)Nn.miniTempBufferIntViews[n]=t.subarray(0,n+1)},recordError:function(e){Nn.lastError||(Nn.lastError=e)},getNewId:function(e){for(var n=Nn.counter++,t=e.length;t<n;t++)e[t]=null;return n},MINI_TEMP_BUFFER_SIZE:256,miniTempBufferFloatViews:[0],miniTempBufferIntViews:[0],getSource:function(e,n,t,a){for(var r="",s=0;s<n;++s){var u=a?o()[a+4*s>>2]:-1;r+=H(o()[t+4*s>>2],u<0?void 0:u)}return r},createContext:function(e,n){var t=e.getContext("webgl",n);return t?Nn.registerContext(t,n):0},registerContext:function(e,n){var t=Qn(8);o()[t+4>>2]=zn();var a={handle:t,attributes:n,version:n.majorVersion,GLctx:e};return e.canvas&&(e.canvas.GLctxObject=a),Nn.contexts[t]=a,(void 0===n.enableExtensionsByDefault||n.enableExtensionsByDefault)&&Nn.initExtensions(a),t},makeContextCurrent:function(e){return Nn.currentContext=Nn.contexts[e],p.ctx=Cn=Nn.currentContext&&Nn.currentContext.GLctx,!(e&&!Cn)},getContext:function(e){return Nn.contexts[e]},deleteContext:function(e){Nn.currentContext===Nn.contexts[e]&&(Nn.currentContext=null),"object"==typeof mn&&mn.removeAllHandlersOnTarget(Nn.contexts[e].GLctx.canvas),Nn.contexts[e]&&Nn.contexts[e].GLctx.canvas&&(Nn.contexts[e].GLctx.canvas.GLctxObject=void 0),Zn(Nn.contexts[e].handle),Nn.contexts[e]=null},initExtensions:function(e){if(e||(e=Nn.currentContext),!e.initExtensionsDone){e.initExtensionsDone=!0;var n=e.GLctx;An(n),Mn(n),xn(n),n.disjointTimerQueryExt=n.getExtension("EXT_disjoint_timer_query");var t=["OES_texture_float","OES_texture_half_float","OES_standard_derivatives","OES_vertex_array_object","WEBGL_compressed_texture_s3tc","WEBGL_depth_texture","OES_element_index_uint","EXT_texture_filter_anisotropic","EXT_frag_depth","WEBGL_draw_buffers","ANGLE_instanced_arrays","OES_texture_float_linear","OES_texture_half_float_linear","EXT_blend_minmax","EXT_shader_texture_lod","EXT_texture_norm16","WEBGL_compressed_texture_pvrtc","EXT_color_buffer_half_float","WEBGL_color_buffer_float","EXT_sRGB","WEBGL_compressed_texture_etc1","EXT_disjoint_timer_query","WEBGL_compressed_texture_etc","WEBGL_compressed_texture_astc","EXT_color_buffer_float","WEBGL_compressed_texture_s3tc_srgb","EXT_disjoint_timer_query_webgl2","WEBKIT_WEBGL_compressed_texture_pvrtc"];(n.getSupportedExtensions()||[]).forEach((function(e){-1!=t.indexOf(e)&&n.getExtension(e)}))}},populateUniformTable:function(e){for(var n=Nn.programs[e],t=Nn.programInfos[e]={uniforms:{},maxUniformLength:0,maxAttributeLength:-1,maxUniformBlockNameLength:-1},a=t.uniforms,r=Cn.getProgramParameter(n,35718),s=0;s<r;++s){var u=Cn.getActiveUniform(n,s),i=u.name;t.maxUniformLength=Math.max(t.maxUniformLength,i.length+1),"]"==i.slice(-1)&&(i=i.slice(0,i.lastIndexOf("[")));var o=Cn.getUniformLocation(n,i);if(o){var l=Nn.getNewId(Nn.uniforms);a[i]=[u.size,l],Nn.uniforms[l]=o;for(var d=1;d<u.size;++d){var c=i+"["+d+"]";o=Cn.getUniformLocation(n,c),l=Nn.getNewId(Nn.uniforms),Nn.uniforms[l]=o}}}}},Fn=["default","low-power","high-performance"];function Tn(e,n){var t={},a=n>>2;t.alpha=!!o()[a+0],t.depth=!!o()[a+1],t.stencil=!!o()[a+2],t.antialias=!!o()[a+3],t.premultipliedAlpha=!!o()[a+4],t.preserveDrawingBuffer=!!o()[a+5];var r=o()[a+6];t.powerPreference=Fn[r],t.failIfMajorPerformanceCaveat=!!o()[a+7],t.majorVersion=o()[a+8],t.minorVersion=o()[a+9],t.enableExtensionsByDefault=o()[a+10],t.explicitSwapControl=o()[a+11],t.proxyContextToMainThread=o()[a+12],t.renderViaOffscreenBackBuffer=o()[a+13];var s=wn(e);return s?t.explicitSwapControl?-1:Nn.createContext(s,t):-4}function On(e,n){return Tn(e,n)}var Cn,Rn={mappings:{},buffers:[null,[],[]],printChar:function(e,n){var t=Rn.buffers[e];0===n||10===n?((1===e?N:F)(L(t,0)),t.length=0):t.push(n)},varargs:void 0,get:function(){return Rn.varargs+=4,o()[Rn.varargs-4>>2]},getStr:function(e){return H(e)},get64:function(e,n){return e}};function Dn(e){return y?sn(3,1,e):0}function Pn(e,n,t,a,r){if(y)return sn(4,1,e,n,t,a,r)}function Wn(e,n,t,a){if(y)return sn(5,1,e,n,t,a);for(var r=0,s=0;s<t;s++){for(var u=o()[n+8*s>>2],l=o()[n+(8*s+4)>>2],d=0;d<l;d++)Rn.printChar(e,i()[u+d]);r+=l}return o()[a>>2]=r,0}function Bn(e){var n=je.exitHandlers.pop();e&&n()}function Ln(e,n){null===je.exitHandlers&&(je.exitHandlers=[]),je.exitHandlers.push((function(){ct(e,n)}))}function Hn(e){if(y)throw"Internal Error! _spawn_thread() can only ever be called from main application thread!";var n=je.getNewWorker();if(void 0!==n.pthread)throw"Internal error!";if(!e.pthread_ptr)throw"Internal error, no pthread ptr!";je.runningWorkers.push(n);for(var t=Qn(512),a=0;a<128;++a)o()[t+4*a>>2]=0;var r=e.stackBase+e.stackSize,s=je.pthreads[e.pthread_ptr]={worker:n,stackBase:e.stackBase,stackSize:e.stackSize,allocatedOwnStack:e.allocatedOwnStack,thread:e.pthread_ptr,threadInfoStruct:e.pthread_ptr},u=s.threadInfoStruct>>2;Atomics.store(l(),u+0,0),Atomics.store(l(),u+1,0),Atomics.store(l(),u+2,0),Atomics.store(l(),u+17,e.detached),Atomics.store(l(),u+26,t),Atomics.store(l(),u+12,0),Atomics.store(l(),u+10,s.threadInfoStruct),Atomics.store(l(),u+11,42),Atomics.store(l(),u+27,e.stackSize),Atomics.store(l(),u+21,e.stackSize),Atomics.store(l(),u+20,r),Atomics.store(l(),u+29,r),Atomics.store(l(),u+30,e.detached),Atomics.store(l(),u+32,e.schedPolicy),Atomics.store(l(),u+33,e.schedPrio);var i=et()+40;Atomics.store(l(),u+44,i),n.pthread=s;var d={cmd:"run",start_routine:e.startRoutine,arg:e.arg,threadInfoStruct:e.pthread_ptr,selfThreadId:e.pthread_ptr,parentThreadId:e.parent_pthread_ptr,stackBase:e.stackBase,stackSize:e.stackSize};n.runPthread=function(){d.time=performance.now(),n.postMessage(d,e.transferList)},n.loaded&&(n.runPthread(),delete n.runPthread)}function Un(e,n,t){if(!n&&!t)return We.EINVAL;if(!e)return F("pthread_getschedparam called with a null thread pointer!"),We.ESRCH;if(o()[e+12>>2]!==e)return F("pthread_getschedparam attempted on thread "+e+", which does not point to a valid thread, or does not exist anymore!"),We.ESRCH;var a=Atomics.load(l(),e+108+20>>2),r=Atomics.load(l(),e+108+24>>2);return n&&(o()[n>>2]=a),t&&(o()[t>>2]=r),0}function zn(){return 0|Ce}function qn(e,n,t,a){if("undefined"==typeof SharedArrayBuffer)return F("Current environment does not support SharedArrayBuffer, pthreads are not available!"),6;if(!e)return F("pthread_create called with a null thread pointer!"),28;var r=[];if(y&&0===r.length)return st(687865856,e,n,t,a);var s=0,u=0,i=0,d=0,c=0;if(n)if(s=o()[n>>2],s+=81920,u=o()[n+8>>2],i=0!==o()[n+12>>2],0===o()[n+16>>2]){var p=o()[n+20>>2],m=o()[n+24>>2];Un(je.currentProxiedOperationCallerThread?je.currentProxiedOperationCallerThread:zn(),n+20,n+24),d=o()[n+20>>2],c=o()[n+24>>2],o()[n+20>>2]=p,o()[n+24>>2]=m}else d=o()[n+20>>2],c=o()[n+24>>2];else s=2097152;var f=0==u;f?u=nt(16,s):D((u-=s)>0);for(var h=Qn(232),b=0;b<58;++b)l()[(h>>2)+b]=0;o()[e>>2]=h,o()[h+12>>2]=h;var _=h+156;o()[_>>2]=_;var g={stackBase:u,stackSize:s,allocatedOwnStack:f,schedPolicy:d,schedPrio:c,detached:i,startRoutine:t,pthread_ptr:h,parent_pthread_ptr:zn(),arg:a,transferList:r};return y?(g.cmd="spawnThread",postMessage(g,r)):Hn(g),0}function jn(e){return(e=+e)>=0?+he(e+.5):+fe(e-.5)}function Vn(e){if(y)return sn(6,1,e);switch(e){case 30:return 16384;case 85:return 131072;case 132:case 133:case 12:case 137:case 138:case 15:case 235:case 16:case 17:case 18:case 19:case 20:case 149:case 13:case 10:case 236:case 153:case 9:case 21:case 22:case 159:case 154:case 14:case 77:case 78:case 139:case 80:case 81:case 82:case 68:case 67:case 164:case 11:case 29:case 47:case 48:case 95:case 52:case 51:case 46:case 79:return 200809;case 27:case 246:case 127:case 128:case 23:case 24:case 160:case 161:case 181:case 182:case 242:case 183:case 184:case 243:case 244:case 245:case 165:case 178:case 179:case 49:case 50:case 168:case 169:case 175:case 170:case 171:case 172:case 97:case 76:case 32:case 173:case 35:return-1;case 176:case 177:case 7:case 155:case 8:case 157:case 125:case 126:case 92:case 93:case 129:case 130:case 131:case 94:case 91:return 1;case 74:case 60:case 69:case 70:case 4:return 1024;case 31:case 42:case 72:return 32;case 87:case 26:case 33:return 2147483647;case 34:case 1:return 47839;case 38:case 36:return 99;case 43:case 37:return 2048;case 0:return 2097152;case 3:return 65536;case 28:return 32768;case 44:return 32767;case 75:return 16384;case 39:return 1e3;case 89:return 700;case 71:return 256;case 40:return 255;case 2:return 100;case 180:return 64;case 25:return 20;case 5:return 16;case 6:return 6;case 73:return 4;case 84:return"object"==typeof navigator&&navigator.hardwareConcurrency||1}return $e(28),-1}p._pthread_self=zn,y?je.initWorker():je.initMainThreadBlock(),Nn.init();var Gn=[null,Ye,In,Dn,Pn,Wn,Vn],Kn={e:Ke,r:Xe,w:Qe,a:Ze,l:Je,d:en,c:Le,h:qe,g:nn,x:tn,q:an,B:rn,t:ln,A:pn,u:vn,k:Sn,s:En,v:On,m:Dn,o:Pn,i:Wn,p:Oe,memory:x||p.wasmMemory,y:Bn,z:Ln,j:qn,b:zn,f:jn,n:Vn,table:O},Xn=Fe();p.asm=Xn;var $n,Yn=p.___wasm_call_ctors=function(){return(Yn=p.___wasm_call_ctors=p.asm.C).apply(null,arguments)},Qn=(p._init=function(){return(p._init=p.asm.D).apply(null,arguments)},p._register_tensor=function(){return(p._register_tensor=p.asm.E).apply(null,arguments)},p._dispose_data=function(){return(p._dispose_data=p.asm.F).apply(null,arguments)},p._dispose=function(){return(p._dispose=p.asm.G).apply(null,arguments)},p._Abs=function(){return(p._Abs=p.asm.H).apply(null,arguments)},p._Add=function(){return(p._Add=p.asm.I).apply(null,arguments)},p._AddN=function(){return(p._AddN=p.asm.J).apply(null,arguments)},p._ArgMax=function(){return(p._ArgMax=p.asm.K).apply(null,arguments)},p._AvgPool=function(){return(p._AvgPool=p.asm.L).apply(null,arguments)},p._BatchMatMul=function(){return(p._BatchMatMul=p.asm.M).apply(null,arguments)},p._ClipByValue=function(){return(p._ClipByValue=p.asm.N).apply(null,arguments)},p._Conv2D=function(){return(p._Conv2D=p.asm.O).apply(null,arguments)},p._Conv2DBackpropInput=function(){return(p._Conv2DBackpropInput=p.asm.P).apply(null,arguments)},p._Cos=function(){return(p._Cos=p.asm.Q).apply(null,arguments)},p._CropAndResize=function(){return(p._CropAndResize=p.asm.R).apply(null,arguments)},p._Cumsum=function(){return(p._Cumsum=p.asm.S).apply(null,arguments)},p._DepthToSpace=function(){return(p._DepthToSpace=p.asm.T).apply(null,arguments)},p._DepthwiseConv2dNative=function(){return(p._DepthwiseConv2dNative=p.asm.U).apply(null,arguments)},p._Equal=function(){return(p._Equal=p.asm.V).apply(null,arguments)},p._Exp=function(){return(p._Exp=p.asm.W).apply(null,arguments)},p._FlipLeftRight=function(){return(p._FlipLeftRight=p.asm.X).apply(null,arguments)},p._Floor=function(){return(p._Floor=p.asm.Y).apply(null,arguments)},p._FloorDiv=function(){return(p._FloorDiv=p.asm.Z).apply(null,arguments)},p._FusedBatchNorm=function(){return(p._FusedBatchNorm=p.asm._).apply(null,arguments)},p._FusedConv2D=function(){return(p._FusedConv2D=p.asm.$).apply(null,arguments)},p._FusedDepthwiseConv2D=function(){return(p._FusedDepthwiseConv2D=p.asm.aa).apply(null,arguments)},p._Gather=function(){return(p._Gather=p.asm.ba).apply(null,arguments)},p._GatherNd=function(){return(p._GatherNd=p.asm.ca).apply(null,arguments)},p._Greater=function(){return(p._Greater=p.asm.da).apply(null,arguments)},p._GreaterEqual=function(){return(p._GreaterEqual=p.asm.ea).apply(null,arguments)},p._LeakyRelu=function(){return(p._LeakyRelu=p.asm.fa).apply(null,arguments)},p._Less=function(){return(p._Less=p.asm.ga).apply(null,arguments)},p._LessEqual=function(){return(p._LessEqual=p.asm.ha).apply(null,arguments)},p._Log=function(){return(p._Log=p.asm.ia).apply(null,arguments)},p._LogicalAnd=function(){return(p._LogicalAnd=p.asm.ja).apply(null,arguments)},p._Max=function(){return(p._Max=p.asm.ka).apply(null,arguments)},p._MaxPool=function(){return(p._MaxPool=p.asm.la).apply(null,arguments)},p._Maximum=function(){return(p._Maximum=p.asm.ma).apply(null,arguments)},p._Mean=function(){return(p._Mean=p.asm.na).apply(null,arguments)},p._Min=function(){return(p._Min=p.asm.oa).apply(null,arguments)},p._Minimum=function(){return(p._Minimum=p.asm.pa).apply(null,arguments)},p._Multiply=function(){return(p._Multiply=p.asm.qa).apply(null,arguments)},p._Neg=function(){return(p._Neg=p.asm.ra).apply(null,arguments)},p._NonMaxSuppressionV3=function(){return(p._NonMaxSuppressionV3=p.asm.sa).apply(null,arguments)},p._NonMaxSuppressionV4=function(){return(p._NonMaxSuppressionV4=p.asm.ta).apply(null,arguments)},p._NonMaxSuppressionV5=function(){return(p._NonMaxSuppressionV5=p.asm.ua).apply(null,arguments)},p._NotEqual=function(){return(p._NotEqual=p.asm.va).apply(null,arguments)},p._OneHot=function(){return(p._OneHot=p.asm.wa).apply(null,arguments)},p._PadV2=function(){return(p._PadV2=p.asm.xa).apply(null,arguments)},p._Pow=function(){return(p._Pow=p.asm.ya).apply(null,arguments)},p._Prelu=function(){return(p._Prelu=p.asm.za).apply(null,arguments)},p._Prod=function(){return(p._Prod=p.asm.Aa).apply(null,arguments)},p._RealDiv=function(){return(p._RealDiv=p.asm.Ba).apply(null,arguments)},p._Relu=function(){return(p._Relu=p.asm.Ca).apply(null,arguments)},p._Relu6=function(){return(p._Relu6=p.asm.Da).apply(null,arguments)},p._ResizeBilinear=function(){return(p._ResizeBilinear=p.asm.Ea).apply(null,arguments)},p._Reverse=function(){return(p._Reverse=p.asm.Fa).apply(null,arguments)},p._RotateWithOffset=function(){return(p._RotateWithOffset=p.asm.Ga).apply(null,arguments)},p._Round=function(){return(p._Round=p.asm.Ha).apply(null,arguments)},p._Rsqrt=function(){return(p._Rsqrt=p.asm.Ia).apply(null,arguments)},p._ScatterNd=function(){return(p._ScatterNd=p.asm.Ja).apply(null,arguments)},p._SelectV2=function(){return(p._SelectV2=p.asm.Ka).apply(null,arguments)},p._Sigmoid=function(){return(p._Sigmoid=p.asm.La).apply(null,arguments)},p._Sin=function(){return(p._Sin=p.asm.Ma).apply(null,arguments)},p._Softmax=function(){return(p._Softmax=p.asm.Na).apply(null,arguments)},p._Sqrt=function(){return(p._Sqrt=p.asm.Oa).apply(null,arguments)},p._Square=function(){return(p._Square=p.asm.Pa).apply(null,arguments)},p._SquaredDifference=function(){return(p._SquaredDifference=p.asm.Qa).apply(null,arguments)},p._Step=function(){return(p._Step=p.asm.Ra).apply(null,arguments)},p._StridedSlice=function(){return(p._StridedSlice=p.asm.Sa).apply(null,arguments)},p._Sub=function(){return(p._Sub=p.asm.Ta).apply(null,arguments)},p._Sum=function(){return(p._Sum=p.asm.Ua).apply(null,arguments)},p._Tanh=function(){return(p._Tanh=p.asm.Va).apply(null,arguments)},p._Tile=function(){return(p._Tile=p.asm.Wa).apply(null,arguments)},p._TopK=function(){return(p._TopK=p.asm.Xa).apply(null,arguments)},p._Transpose=function(){return(p._Transpose=p.asm.Ya).apply(null,arguments)},p.__FusedMatMul=function(){return(p.__FusedMatMul=p.asm.Za).apply(null,arguments)},p._malloc=function(){return(Qn=p._malloc=p.asm._a).apply(null,arguments)}),Zn=p._free=function(){return(Zn=p._free=p.asm.$a).apply(null,arguments)},Jn=p.___errno_location=function(){return(Jn=p.___errno_location=p.asm.ab).apply(null,arguments)},et=p._emscripten_get_global_libc=function(){return(et=p._emscripten_get_global_libc=p.asm.bb).apply(null,arguments)},nt=(p.___em_js__initPthreadsJS=function(){return(p.___em_js__initPthreadsJS=p.asm.cb).apply(null,arguments)},p._memalign=function(){return(nt=p._memalign=p.asm.db).apply(null,arguments)}),tt=p.___pthread_tsd_run_dtors=function(){return(tt=p.___pthread_tsd_run_dtors=p.asm.eb).apply(null,arguments)},at=p._emscripten_main_thread_process_queued_calls=function(){return(at=p._emscripten_main_thread_process_queued_calls=p.asm.fb).apply(null,arguments)},rt=(p._emscripten_current_thread_process_queued_calls=function(){return(p._emscripten_current_thread_process_queued_calls=p.asm.gb).apply(null,arguments)},p._emscripten_register_main_browser_thread_id=function(){return(rt=p._emscripten_register_main_browser_thread_id=p.asm.hb).apply(null,arguments)}),st=(p._emscripten_main_browser_thread_id=function(){return(p._emscripten_main_browser_thread_id=p.asm.ib).apply(null,arguments)},p._emscripten_async_run_in_main_thread=function(){return(p._emscripten_async_run_in_main_thread=p.asm.jb).apply(null,arguments)},p._emscripten_sync_run_in_main_thread=function(){return(p._emscripten_sync_run_in_main_thread=p.asm.kb).apply(null,arguments)},p._emscripten_sync_run_in_main_thread_0=function(){return(p._emscripten_sync_run_in_main_thread_0=p.asm.lb).apply(null,arguments)},p._emscripten_sync_run_in_main_thread_1=function(){return(p._emscripten_sync_run_in_main_thread_1=p.asm.mb).apply(null,arguments)},p._emscripten_sync_run_in_main_thread_2=function(){return(p._emscripten_sync_run_in_main_thread_2=p.asm.nb).apply(null,arguments)},p._emscripten_sync_run_in_main_thread_xprintf_varargs=function(){return(p._emscripten_sync_run_in_main_thread_xprintf_varargs=p.asm.ob).apply(null,arguments)},p._emscripten_sync_run_in_main_thread_3=function(){return(p._emscripten_sync_run_in_main_thread_3=p.asm.pb).apply(null,arguments)},p._emscripten_sync_run_in_main_thread_4=function(){return(st=p._emscripten_sync_run_in_main_thread_4=p.asm.qb).apply(null,arguments)}),ut=(p._emscripten_sync_run_in_main_thread_5=function(){return(p._emscripten_sync_run_in_main_thread_5=p.asm.rb).apply(null,arguments)},p._emscripten_sync_run_in_main_thread_6=function(){return(p._emscripten_sync_run_in_main_thread_6=p.asm.sb).apply(null,arguments)},p._emscripten_sync_run_in_main_thread_7=function(){return(p._emscripten_sync_run_in_main_thread_7=p.asm.tb).apply(null,arguments)},p._emscripten_run_in_main_runtime_thread_js=function(){return(ut=p._emscripten_run_in_main_runtime_thread_js=p.asm.ub).apply(null,arguments)}),it=p._emscripten_async_queue_on_thread_=function(){return(it=p._emscripten_async_queue_on_thread_=p.asm.vb).apply(null,arguments)},ot=(p._emscripten_tls_init=function(){return(p._emscripten_tls_init=p.asm.wb).apply(null,arguments)},p.stackSave=function(){return(ot=p.stackSave=p.asm.xb).apply(null,arguments)}),lt=p.stackAlloc=function(){return(lt=p.stackAlloc=p.asm.yb).apply(null,arguments)},dt=p.stackRestore=function(){return(dt=p.stackRestore=p.asm.zb).apply(null,arguments)},ct=p.dynCall_vi=function(){return(ct=p.dynCall_vi=p.asm.Ab).apply(null,arguments)};function pt(e){this.name="ExitStatus",this.message="Program terminated with exit("+e+")",this.status=e}function mt(e){function n(){$n||($n=!0,p.calledRun=!0,R||(le(),de(),p.onRuntimeInitialized&&p.onRuntimeInitialized(),ce()))}be>0||(oe(),be>0||(p.setStatus?(p.setStatus("Running..."),setTimeout((function(){setTimeout((function(){p.setStatus("")}),1),n()}),1)):n()))}if(p.dynCall_v=function(){return(p.dynCall_v=p.asm.Bb).apply(null,arguments)},p.dynCall_ii=function(){return(p.dynCall_ii=p.asm.Cb).apply(null,arguments)},p.asm=Xn,p.cwrap=B,p.PThread=je,p.PThread=je,p._pthread_self=zn,p.wasmMemory=x,p.ExitStatus=pt,p.then=function(e){if($n)e(p);else{var n=p.onRuntimeInitialized;p.onRuntimeInitialized=function(){n&&n(),e(p)}}return p},ye=function e(){$n||mt(),$n||(ye=e)},p.run=mt,p.preInit)for("function"==typeof p.preInit&&(p.preInit=[p.preInit]);p.preInit.length>0;)p.preInit.pop()();return y||(M=!0),y||mt(),e});e.exports=i}));var Mn=En((function(e,n){var r,s=(r="undefined"!=typeof document&&document.currentScript?document.currentScript.src:void 0,"undefined"!=typeof __filename&&(r=r||__filename),function(e){var n,s=void 0!==(e=e||{})?e:{},u={};for(n in s)s.hasOwnProperty(n)&&(u[n]=s[n]);var i=function(e,n){throw n},o=!1,l=!1,d=!1,c=!1;o="object"==typeof window,l="function"==typeof importScripts,d="object"==typeof process&&"object"==typeof process.versions&&"string"==typeof process.versions.node,c=!o&&!d&&!l;var p,m,f,h,b="";function _(e){return s.locateFile?s.locateFile(e,b):b+e}d?(b=l?t.dirname(b)+"/":__dirname+"/",p=function(e,n){return f||(f=a),h||(h=t),e=h.normalize(e),f.readFileSync(e,n?null:"utf8")},m=function(e){var n=p(e,!0);return n.buffer||(n=new Uint8Array(n)),S(n.buffer),n},process.argv.length>1&&process.argv[1].replace(/\\/g,"/"),process.argv.slice(2),process.on("uncaughtException",(function(e){if(!(e instanceof Ae))throw e})),process.on("unhandledRejection",te),i=function(e){process.exit(e)},s.inspect=function(){return"[Emscripten Module object]"}):c?("undefined"!=typeof read&&(p=function(e){return read(e)}),m=function(e){var n;return"function"==typeof readbuffer?new Uint8Array(readbuffer(e)):(S("object"==typeof(n=read(e,"binary"))),n)},"undefined"!=typeof scriptArgs&&scriptArgs,"function"==typeof quit&&(i=function(e){quit(e)}),"undefined"!=typeof print&&("undefined"==typeof console&&(console={}),console.log=print,console.warn=console.error="undefined"!=typeof printErr?printErr:print)):(o||l)&&(l?b=self.location.href:document.currentScript&&(b=document.currentScript.src),r&&(b=r),b=0!==b.indexOf("blob:")?b.substr(0,b.lastIndexOf("/")+1):"",p=function(e){var n=new XMLHttpRequest;return n.open("GET",e,!1),n.send(null),n.responseText},l&&(m=function(e){var n=new XMLHttpRequest;return n.open("GET",e,!1),n.responseType="arraybuffer",n.send(null),new Uint8Array(n.response)}));var y,g,w,k=s.print||console.log.bind(console),I=s.printErr||console.warn.bind(console);for(n in u)u.hasOwnProperty(n)&&(s[n]=u[n]);u=null,s.arguments&&s.arguments,s.thisProgram&&s.thisProgram,s.quit&&(i=s.quit),s.wasmBinary&&(y=s.wasmBinary),s.noExitRuntime&&(g=s.noExitRuntime),"object"!=typeof WebAssembly&&I("no native wasm support detected"),new WebAssembly.Table({initial:151,maximum:151,element:"anyfunc"});var v=!1;function S(e,n){e||te("Assertion failed: "+n)}function E(e){var n=s["_"+e];return S(n,"Cannot call unknown function "+e+", make sure it is exported"),n}function A(e,n,t,a,r){var s={string:function(e){var n=0;if(null!=e&&0!==e){var t=1+(e.length<<2);D(e,n=Se(t),t)}return n},array:function(e){var n=Se(e.length);return P(e,n),n}},u=E(e),i=[],o=0;if(a)for(var l=0;l<a.length;l++){var d=s[t[l]];d?(0===o&&(o=ve()),i[l]=d(a[l])):i[l]=a[l]}var c=u.apply(null,i);return c=function(e){return"string"===n?C(e):"boolean"===n?Boolean(e):e}(c),0!==o&&Ee(o),c}function M(e,n,t,a){var r=(t=t||[]).every((function(e){return"number"===e}));return"string"!==n&&r&&!a?E(e):function(){return A(e,n,t,arguments)}}var x,N,F,T="undefined"!=typeof TextDecoder?new TextDecoder("utf8"):void 0;function O(e,n,t){for(var a=n+t,r=n;e[r]&&!(r>=a);)++r;if(r-n>16&&e.subarray&&T)return T.decode(e.subarray(n,r));for(var s="";n<r;){var u=e[n++];if(128&u){var i=63&e[n++];if(192!=(224&u)){var o=63&e[n++];if((u=224==(240&u)?(15&u)<<12|i<<6|o:(7&u)<<18|i<<12|o<<6|63&e[n++])<65536)s+=String.fromCharCode(u);else{var l=u-65536;s+=String.fromCharCode(55296|l>>10,56320|1023&l)}}else s+=String.fromCharCode((31&u)<<6|i)}else s+=String.fromCharCode(u)}return s}function C(e,n){return e?O(N,e,n):""}function R(e,n,t,a){if(!(a>0))return 0;for(var r=t,s=t+a-1,u=0;u<e.length;++u){var i=e.charCodeAt(u);if(i>=55296&&i<=57343&&(i=65536+((1023&i)<<10)|1023&e.charCodeAt(++u)),i<=127){if(t>=s)break;n[t++]=i}else if(i<=2047){if(t+1>=s)break;n[t++]=192|i>>6,n[t++]=128|63&i}else if(i<=65535){if(t+2>=s)break;n[t++]=224|i>>12,n[t++]=128|i>>6&63,n[t++]=128|63&i}else{if(t+3>=s)break;n[t++]=240|i>>18,n[t++]=128|i>>12&63,n[t++]=128|i>>6&63,n[t++]=128|63&i}}return n[t]=0,t-r}function D(e,n,t){return R(e,N,n,t)}function P(e,n){x.set(e,n)}function W(e){s.HEAP8=x=new Int8Array(e),s.HEAP16=new Int16Array(e),s.HEAP32=F=new Int32Array(e),s.HEAPU8=N=new Uint8Array(e),s.HEAPU16=new Uint16Array(e),s.HEAPU32=new Uint32Array(e),s.HEAPF32=new Float32Array(e),s.HEAPF64=new Float64Array(e)}function B(e){for(;e.length>0;){var n=e.shift();if("function"!=typeof n){var t=n.func;"number"==typeof t?void 0===n.arg?s.dynCall_v(t):s.dynCall_vi(t,n.arg):t(void 0===n.arg?null:n.arg)}else n(s)}}s.INITIAL_MEMORY;var L=[],H=[],U=[],z=[];function q(){if(s.preRun)for("function"==typeof s.preRun&&(s.preRun=[s.preRun]);s.preRun.length;)K(s.preRun.shift());B(L)}function j(){B(H)}function V(){B(U)}function G(){if(s.postRun)for("function"==typeof s.postRun&&(s.postRun=[s.postRun]);s.postRun.length;)X(s.postRun.shift());B(z)}function K(e){L.unshift(e)}function X(e){z.unshift(e)}var $=Math.ceil,Y=Math.floor,Q=0,Z=null,J=null;function ee(e){Q++,s.monitorRunDependencies&&s.monitorRunDependencies(Q)}function ne(e){if(Q--,s.monitorRunDependencies&&s.monitorRunDependencies(Q),0==Q&&(null!==Z&&(clearInterval(Z),Z=null),J)){var n=J;J=null,n()}}function te(e){throw s.onAbort&&s.onAbort(e),k(e+=""),I(e),v=!0,e="abort("+e+"). Build with -s ASSERTIONS=1 for more info.",new WebAssembly.RuntimeError(e)}function ae(e,n){return String.prototype.startsWith?e.startsWith(n):0===e.indexOf(n)}s.preloadedImages={},s.preloadedAudios={};var re="data:application/octet-stream;base64,";function se(e){return ae(e,re)}var ue="file://";function ie(e){return ae(e,ue)}var oe="tfjs-backend-wasm.wasm";function le(){try{if(y)return new Uint8Array(y);if(m)return m(oe);throw"both async and sync fetching of the wasm failed"}catch(e){te(e)}}function de(){return y||!o&&!l||"function"!=typeof fetch||ie(oe)?new Promise((function(e,n){e(le())})):fetch(oe,{credentials:"same-origin"}).then((function(e){if(!e.ok)throw"failed to load wasm binary file at '"+oe+"'";return e.arrayBuffer()})).catch((function(){return le()}))}function ce(){var e={env:we,wasi_snapshot_preview1:we};function n(e,n){var t=e.exports;s.asm=t,W((w=t.memory).buffer),ne()}function t(e){n(e.instance)}function a(n){return de().then((function(n){return WebAssembly.instantiate(n,e)})).then(n,(function(e){I("failed to asynchronously prepare wasm: "+e),te(e)}))}if(ee(),s.instantiateWasm)try{return s.instantiateWasm(e,n)}catch(e){return I("Module.instantiateWasm callback failed with error: "+e),!1}return function(){if(y||"function"!=typeof WebAssembly.instantiateStreaming||se(oe)||ie(oe)||"function"!=typeof fetch)return a(t);fetch(oe,{credentials:"same-origin"}).then((function(n){return WebAssembly.instantiateStreaming(n,e).then(t,(function(e){I("wasm streaming compile failed: "+e),I("falling back to ArrayBuffer instantiation"),a(t)}))}))}(),{}}function pe(e){W(w.buffer)}se(oe)||(oe=_(oe)),H.push();var me={mappings:{},buffers:[null,[],[]],printChar:function(e,n){var t=me.buffers[e];0===n||10===n?((1===e?k:I)(O(t,0)),t.length=0):t.push(n)},varargs:void 0,get:function(){return me.varargs+=4,F[me.varargs-4>>2]},getStr:function(e){return C(e)},get64:function(e,n){return e}};function fe(e){return 0}function he(e,n,t,a,r){}function be(e,n,t,a){for(var r=0,s=0;s<t;s++){for(var u=F[n+8*s>>2],i=F[n+(8*s+4)>>2],o=0;o<i;o++)me.printChar(e,N[u+o]);r+=i}return F[a>>2]=r,0}function _e(e){Ne(e)}function ye(e){_e(e)}function ge(e){return(e=+e)>=0?+Y(e+.5):+$(e-.5)}var we={emscripten_notify_memory_growth:pe,fd_close:fe,fd_seek:he,fd_write:be,proc_exit:ye,roundf:ge},ke=ce();s.asm=ke,s._init=function(){return(s._init=s.asm.init).apply(null,arguments)},s._register_tensor=function(){return(s._register_tensor=s.asm.register_tensor).apply(null,arguments)},s._dispose_data=function(){return(s._dispose_data=s.asm.dispose_data).apply(null,arguments)},s._dispose=function(){return(s._dispose=s.asm.dispose).apply(null,arguments)},s._Abs=function(){return(s._Abs=s.asm.Abs).apply(null,arguments)},s._Add=function(){return(s._Add=s.asm.Add).apply(null,arguments)},s._AddN=function(){return(s._AddN=s.asm.AddN).apply(null,arguments)},s._ArgMax=function(){return(s._ArgMax=s.asm.ArgMax).apply(null,arguments)},s._AvgPool=function(){return(s._AvgPool=s.asm.AvgPool).apply(null,arguments)},s._BatchMatMul=function(){return(s._BatchMatMul=s.asm.BatchMatMul).apply(null,arguments)},s._ClipByValue=function(){return(s._ClipByValue=s.asm.ClipByValue).apply(null,arguments)},s._Conv2D=function(){return(s._Conv2D=s.asm.Conv2D).apply(null,arguments)},s._Conv2DBackpropInput=function(){return(s._Conv2DBackpropInput=s.asm.Conv2DBackpropInput).apply(null,arguments)},s._Cos=function(){return(s._Cos=s.asm.Cos).apply(null,arguments)},s._CropAndResize=function(){return(s._CropAndResize=s.asm.CropAndResize).apply(null,arguments)},s._Cumsum=function(){return(s._Cumsum=s.asm.Cumsum).apply(null,arguments)},s._DepthToSpace=function(){return(s._DepthToSpace=s.asm.DepthToSpace).apply(null,arguments)},s._DepthwiseConv2dNative=function(){return(s._DepthwiseConv2dNative=s.asm.DepthwiseConv2dNative).apply(null,arguments)},s._Equal=function(){return(s._Equal=s.asm.Equal).apply(null,arguments)},s._Exp=function(){return(s._Exp=s.asm.Exp).apply(null,arguments)},s._FlipLeftRight=function(){return(s._FlipLeftRight=s.asm.FlipLeftRight).apply(null,arguments)},s._Floor=function(){return(s._Floor=s.asm.Floor).apply(null,arguments)},s._FloorDiv=function(){return(s._FloorDiv=s.asm.FloorDiv).apply(null,arguments)},s._FusedBatchNorm=function(){return(s._FusedBatchNorm=s.asm.FusedBatchNorm).apply(null,arguments)},s._FusedConv2D=function(){return(s._FusedConv2D=s.asm.FusedConv2D).apply(null,arguments)},s._FusedDepthwiseConv2D=function(){return(s._FusedDepthwiseConv2D=s.asm.FusedDepthwiseConv2D).apply(null,arguments)},s._Gather=function(){return(s._Gather=s.asm.Gather).apply(null,arguments)},s._GatherNd=function(){return(s._GatherNd=s.asm.GatherNd).apply(null,arguments)},s._Greater=function(){return(s._Greater=s.asm.Greater).apply(null,arguments)},s._GreaterEqual=function(){return(s._GreaterEqual=s.asm.GreaterEqual).apply(null,arguments)},s._LeakyRelu=function(){return(s._LeakyRelu=s.asm.LeakyRelu).apply(null,arguments)},s._Less=function(){return(s._Less=s.asm.Less).apply(null,arguments)},s._LessEqual=function(){return(s._LessEqual=s.asm.LessEqual).apply(null,arguments)},s._Log=function(){return(s._Log=s.asm.Log).apply(null,arguments)},s._LogicalAnd=function(){return(s._LogicalAnd=s.asm.LogicalAnd).apply(null,arguments)},s._Max=function(){return(s._Max=s.asm.Max).apply(null,arguments)},s._MaxPool=function(){return(s._MaxPool=s.asm.MaxPool).apply(null,arguments)},s._Maximum=function(){return(s._Maximum=s.asm.Maximum).apply(null,arguments)},s._Mean=function(){return(s._Mean=s.asm.Mean).apply(null,arguments)},s._Min=function(){return(s._Min=s.asm.Min).apply(null,arguments)},s._Minimum=function(){return(s._Minimum=s.asm.Minimum).apply(null,arguments)},s._Multiply=function(){return(s._Multiply=s.asm.Multiply).apply(null,arguments)},s._Neg=function(){return(s._Neg=s.asm.Neg).apply(null,arguments)},s._NonMaxSuppressionV3=function(){return(s._NonMaxSuppressionV3=s.asm.NonMaxSuppressionV3).apply(null,arguments)},s._NonMaxSuppressionV4=function(){return(s._NonMaxSuppressionV4=s.asm.NonMaxSuppressionV4).apply(null,arguments)},s._NonMaxSuppressionV5=function(){return(s._NonMaxSuppressionV5=s.asm.NonMaxSuppressionV5).apply(null,arguments)},s._NotEqual=function(){return(s._NotEqual=s.asm.NotEqual).apply(null,arguments)},s._OneHot=function(){return(s._OneHot=s.asm.OneHot).apply(null,arguments)},s._PadV2=function(){return(s._PadV2=s.asm.PadV2).apply(null,arguments)},s._Pow=function(){return(s._Pow=s.asm.Pow).apply(null,arguments)},s._Prelu=function(){return(s._Prelu=s.asm.Prelu).apply(null,arguments)},s._Prod=function(){return(s._Prod=s.asm.Prod).apply(null,arguments)},s._RealDiv=function(){return(s._RealDiv=s.asm.RealDiv).apply(null,arguments)},s._Relu=function(){return(s._Relu=s.asm.Relu).apply(null,arguments)},s._Relu6=function(){return(s._Relu6=s.asm.Relu6).apply(null,arguments)},s._ResizeBilinear=function(){return(s._ResizeBilinear=s.asm.ResizeBilinear).apply(null,arguments)},s._Reverse=function(){return(s._Reverse=s.asm.Reverse).apply(null,arguments)},s._RotateWithOffset=function(){return(s._RotateWithOffset=s.asm.RotateWithOffset).apply(null,arguments)},s._Round=function(){return(s._Round=s.asm.Round).apply(null,arguments)},s._Rsqrt=function(){return(s._Rsqrt=s.asm.Rsqrt).apply(null,arguments)},s._ScatterNd=function(){return(s._ScatterNd=s.asm.ScatterNd).apply(null,arguments)},s._SelectV2=function(){return(s._SelectV2=s.asm.SelectV2).apply(null,arguments)},s._Sigmoid=function(){return(s._Sigmoid=s.asm.Sigmoid).apply(null,arguments)},s._Sin=function(){return(s._Sin=s.asm.Sin).apply(null,arguments)},s._Softmax=function(){return(s._Softmax=s.asm.Softmax).apply(null,arguments)},s._Sqrt=function(){return(s._Sqrt=s.asm.Sqrt).apply(null,arguments)},s._Square=function(){return(s._Square=s.asm.Square).apply(null,arguments)},s._SquaredDifference=function(){return(s._SquaredDifference=s.asm.SquaredDifference).apply(null,arguments)},s._Step=function(){return(s._Step=s.asm.Step).apply(null,arguments)},s._StridedSlice=function(){return(s._StridedSlice=s.asm.StridedSlice).apply(null,arguments)},s._Sub=function(){return(s._Sub=s.asm.Sub).apply(null,arguments)},s._Sum=function(){return(s._Sum=s.asm.Sum).apply(null,arguments)},s._Tanh=function(){return(s._Tanh=s.asm.Tanh).apply(null,arguments)},s._Tile=function(){return(s._Tile=s.asm.Tile).apply(null,arguments)},s._TopK=function(){return(s._TopK=s.asm.TopK).apply(null,arguments)},s._Transpose=function(){return(s._Transpose=s.asm.Transpose).apply(null,arguments)},s.__FusedMatMul=function(){return(s.__FusedMatMul=s.asm._FusedMatMul).apply(null,arguments)},s._malloc=function(){return(s._malloc=s.asm.malloc).apply(null,arguments)},s._free=function(){return(s._free=s.asm.free).apply(null,arguments)},s.__start=function(){return(s.__start=s.asm._start).apply(null,arguments)};var Ie,ve=s.stackSave=function(){return(ve=s.stackSave=s.asm.stackSave).apply(null,arguments)},Se=s.stackAlloc=function(){return(Se=s.stackAlloc=s.asm.stackAlloc).apply(null,arguments)},Ee=s.stackRestore=function(){return(Ee=s.stackRestore=s.asm.stackRestore).apply(null,arguments)};function Ae(e){this.name="ExitStatus",this.message="Program terminated with exit("+e+")",this.status=e}function Me(e){var n=s.__start;try{n(),Ne(0,!0)}catch(e){if(e instanceof Ae)return;if("unwind"==e)return void(g=!0);var t=e;e&&"object"==typeof e&&e.stack&&(t=[e,e.stack]),I("exception thrown: "+t),i(1,e)}}function xe(e){function n(){Ie||(Ie=!0,s.calledRun=!0,v||(j(),V(),s.onRuntimeInitialized&&s.onRuntimeInitialized(),Fe&&Me(),G()))}Q>0||(q(),Q>0||(s.setStatus?(s.setStatus("Running..."),setTimeout((function(){setTimeout((function(){s.setStatus("")}),1),n()}),1)):n()))}function Ne(e,n){n&&g&&0===e||(g||(v=!0,s.onExit&&s.onExit(e)),i(e,new Ae(e)))}if(s.asm=ke,s.cwrap=M,s.then=function(e){if(Ie)e(s);else{var n=s.onRuntimeInitialized;s.onRuntimeInitialized=function(){n&&n(),e(s)}}return s},J=function e(){Ie||xe(),Ie||(J=e)},s.run=xe,s.preInit)for("function"==typeof s.preInit&&(s.preInit=[s.preInit]);s.preInit.length>0;)s.preInit.pop()();var Fe=!0;return s.noInitialRun&&(Fe=!1),g=!0,xe(),e});e.exports=s}));class xn extends n.KernelBackend{constructor(e){super(),this.wasm=e,this.dataIdNextNumber=1,this.wasm.tfjs.init(),this.dataIdMap=new n.DataStorage(this,n.engine())}write(e,n,t){const a={};return this.move(a,e,n,t),a}numDataIds(){return this.dataIdMap.numDataIds()}async time(e){const t=n.util.now();e();return{kernelMs:n.util.now()-t}}move(e,t,a,r){const s=this.dataIdNextNumber++;if("string"===r){const n=t;return void this.dataIdMap.set(e,{id:s,stringBytes:n,shape:a,dtype:r,memoryOffset:null})}const u=n.util.sizeFromShape(a),i=u*n.util.bytesPerElement(r),o=this.wasm._malloc(i);this.dataIdMap.set(e,{id:s,memoryOffset:o,shape:a,dtype:r}),this.wasm.tfjs.registerTensor(s,u,o),null!=t&&this.wasm.HEAPU8.set(new Uint8Array(t.buffer,t.byteOffset,i),o)}async read(e){return this.readSync(e)}readSync(e){const{memoryOffset:t,dtype:a,shape:r,stringBytes:s}=this.dataIdMap.get(e);if("string"===a)return s;return function(e,n){switch(n){case"float32":return new Float32Array(e);case"int32":return new Int32Array(e);case"bool":return new Uint8Array(e);default:throw new Error("Unknown dtype "+n)}}(this.wasm.HEAPU8.slice(t,t+n.util.sizeFromShape(r)*n.util.bytesPerElement(a)).buffer,a)}disposeData(e){const n=this.dataIdMap.get(e);this.wasm._free(n.memoryOffset),this.wasm.tfjs.disposeData(n.id),this.dataIdMap.delete(e)}floatPrecision(){return 32}getMemoryOffset(e){return this.dataIdMap.get(e).memoryOffset}dispose(){this.wasm.tfjs.dispose(),this.wasm=null}memory(){return{unreliable:!1}}makeOutput(e,t,a){let r;if(null==a)r=this.write(null,e,t);else{r={};const s=this.dataIdNextNumber++;this.dataIdMap.set(r,{id:s,memoryOffset:a,shape:e,dtype:t});const u=n.util.sizeFromShape(e);this.wasm.tfjs.registerTensor(s,u,a)}return{dataId:r,shape:e,dtype:t}}typedArrayFromHeap({shape:e,dtype:t,dataId:a}){const r=this.wasm.HEAPU8.buffer,{memoryOffset:s}=this.dataIdMap.get(a),u=n.util.sizeFromShape(e);switch(t){case"float32":return new Float32Array(r,s,u);case"int32":return new Int32Array(r,s,u);case"bool":return new Uint8Array(r,s,u);default:throw new Error("Unknown dtype "+t)}}}function Nn(e,n,t){if(null!=On)return On;let a="tfjs-backend-wasm.wasm";return e&&n?a="tfjs-backend-wasm-threaded-simd.wasm":e&&(a="tfjs-backend-wasm-simd.wasm"),null!=Rn&&null!=Rn[a]?Rn[a]:t+a}async function Fn(){const[e,t]=await Promise.all([n.env().getAsync("WASM_HAS_SIMD_SUPPORT"),n.env().getAsync("WASM_HAS_MULTITHREAD_SUPPORT")]);return new Promise((a,r)=>{const s={};let u;if(s.locateFile=(n,a)=>{if(n.endsWith(".worker.js")){const e=new Blob(['var threadInfoStruct=0;var selfThreadId=0;var parentThreadId=0;var Module={};function threadPrintErr(){var text=Array.prototype.slice.call(arguments).join(" ");console.error(text)}function threadAlert(){var text=Array.prototype.slice.call(arguments).join(" ");postMessage({cmd:"alert",text:text,threadId:selfThreadId})}var err=threadPrintErr;this.alert=threadAlert;Module["instantiateWasm"]=function(info,receiveInstance){var instance=new WebAssembly.Instance(Module["wasmModule"],info);Module["wasmModule"]=null;receiveInstance(instance);return instance.exports};this.onmessage=function(e){try{if(e.data.cmd==="load"){Module["DYNAMIC_BASE"]=e.data.DYNAMIC_BASE;Module["DYNAMICTOP_PTR"]=e.data.DYNAMICTOP_PTR;Module["wasmModule"]=e.data.wasmModule;Module["wasmMemory"]=e.data.wasmMemory;Module["buffer"]=Module["wasmMemory"].buffer;Module["ENVIRONMENT_IS_PTHREAD"]=true;if(typeof e.data.urlOrBlob==="string"){importScripts(e.data.urlOrBlob)}else{var objectUrl=URL.createObjectURL(e.data.urlOrBlob);importScripts(objectUrl);URL.revokeObjectURL(objectUrl)}Module=WasmBackendModuleThreadedSimd(Module);postMessage({"cmd":"loaded"})}else if(e.data.cmd==="objectTransfer"){Module["PThread"].receiveObjectTransfer(e.data)}else if(e.data.cmd==="run"){Module["__performance_now_clock_drift"]=performance.now()-e.data.time;threadInfoStruct=e.data.threadInfoStruct;Module["__register_pthread_ptr"](threadInfoStruct,0,0);selfThreadId=e.data.selfThreadId;parentThreadId=e.data.parentThreadId;var max=e.data.stackBase;var top=e.data.stackBase+e.data.stackSize;Module["establishStackSpace"](top,max);Module["_emscripten_tls_init"]();Module["PThread"].receiveObjectTransfer(e.data);Module["PThread"].setThreadStatus(Module["_pthread_self"](),1);try{var result=Module["dynCall_ii"](e.data.start_routine,e.data.arg);if(!Module["getNoExitRuntime"]())Module["PThread"].threadExit(result)}catch(ex){if(ex==="Canceled!"){Module["PThread"].threadCancel()}else if(ex!="unwind"){Atomics.store(Module["HEAPU32"],threadInfoStruct+4>>2,ex instanceof Module["ExitStatus"]?ex.status:-2);Atomics.store(Module["HEAPU32"],threadInfoStruct+0>>2,1);Module["_emscripten_futex_wake"](threadInfoStruct+0,2147483647);if(!(ex instanceof Module["ExitStatus"]))throw ex}}}else if(e.data.cmd==="cancel"){if(threadInfoStruct){Module["PThread"].threadCancel()}}else if(e.data.target==="setimmediate"){}else if(e.data.cmd==="processThreadQueue"){if(threadInfoStruct){Module["_emscripten_current_thread_process_queued_calls"]()}}else{err("worker.js received unknown command "+e.data.cmd);err(e.data)}}catch(ex){err("worker.js onmessage() captured an uncaught exception: "+ex);if(ex.stack)err(ex.stack);throw ex}};if(typeof process==="object"&&typeof process.versions==="object"&&typeof process.versions.node==="string"){self={location:{href:__filename}};var onmessage=this.onmessage;var nodeWorkerThreads=require("worker_threads");Worker=nodeWorkerThreads.Worker;var parentPort=nodeWorkerThreads.parentPort;parentPort.on("message",function(data){onmessage({data:data})});var nodeFS=require("fs");var nodeRead=function(filename){return nodeFS.readFileSync(filename,"utf8")};function globalEval(x){global.require=require;global.Module=Module;eval.call(null,x)}importScripts=function(f){globalEval(nodeRead(f))};postMessage=function(msg){parentPort.postMessage(msg)};if(typeof performance==="undefined"){performance={now:function(){return Date.now()}}}}'],{type:"application/javascript"});return URL.createObjectURL(e)}return n.endsWith(".wasm")?Nn(e,t,null!=Cn?Cn:a):a+n},Pn&&(s.instantiateWasm=function(e){return(t,a)=>(n.util.fetch(e,{credentials:"same-origin"}).then(n=>{n.ok||t.env.a(`failed to load wasm binary file at '${e}'`),n.arrayBuffer().then(e=>{WebAssembly.instantiate(e,t).then(e=>{a(e.instance)})})}),{})}(Nn(e,t,null!=Cn?Cn:""))),t&&e&&null==On){u=An(s);let e=An.toString();e=e.replace(/if\s*\(\s*_scriptDir\s*\)/g,'if(typeof _scriptDir !== "undefined" && _scriptDir)'),u.mainScriptUrlOrBlob=new Blob(["var WasmBackendModuleThreadedSimd = "+e],{type:"text/javascript"})}else u=Mn(s);u.tfjs={init:u.cwrap("init",null,[]),registerTensor:u.cwrap("register_tensor",null,["number","number","number"]),disposeData:u.cwrap("dispose_data",null,["number"]),dispose:u.cwrap("dispose",null,[])};let i=!1;u.onRuntimeInitialized=()=>{i=!0,Dn=!1,a({wasm:u})},u.onAbort=()=>{if(i)return;if(Dn)return;Dn=!0;r({message:"Make sure the server can serve the `.wasm` file relative to the bundled js file. For more details see https://github.com/tensorflow/tfjs/blob/master/tfjs-backend-wasm/README.md#using-bundlers"})}})}const Tn=["tfjs-backend-wasm.wasm","tfjs-backend-wasm-simd.wasm","tfjs-backend-wasm-threaded-simd.wasm"];let On=null,Cn=null,Rn={},Dn=!1,Pn=!1;n.registerBackend("wasm",async()=>{const{wasm:e}=await Fn();return new xn(e)},2),e.BackendWasm=xn,e.setWasmPath=function(e,t=!1){if(n.deprecationWarn("setWasmPath has been deprecated in favor of setWasmPaths and will be removed in a future release."),Dn)throw new Error("The WASM backend was already initialized. Make sure you call `setWasmPath()` before you call `tf.setBackend()` or `tf.ready()`");On=e,Pn=t},e.setWasmPaths=function(e,n=!1){if(Dn)throw new Error("The WASM backend was already initialized. Make sure you call `setWasmPaths()` before you call `tf.setBackend()` or `tf.ready()`");if("string"==typeof e)Cn=e;else{Rn=e;const n=Tn.filter(e=>null==Rn[e]);if(n.length>0)throw new Error("There were no entries found for the following binaries: "+n.join(",")+". Please either call setWasmPaths with a map providing a path for each binary, or with a string indicating the directory where all the binaries can be found.")}Pn=n},e.version_wasm="2.8.4",Object.defineProperty(e,"__esModule",{value:!0})}));
//# sourceMappingURL=tf-backend-wasm.es2017.min.js.map
